#!/usr/bin/perl
print "Content-type:text/html\n\n";

@values = split (/&/,$ENV{'QUERY_STRING'});
foreach $i (@values) {
	($varname, $mydata) = split(/=/,$i);
# translate out all the Masked Symbols
	$varname =~ tr/+/ /;
	$varname =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$mydata =~ tr/+/ /;
	$mydata =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
# Store the Pair Info, check for duplicates

	if (defined($getpairs{$varname})) {
	$getpairs{$varname} = "$getpairs{$varname}, $mydata";
	}
	else {
	$getpairs{$varname} = $mydata;
	}

# A Debug Step to output all GetPairs.
#	print "get - $varname = $getpairs{$varname}<br>\n";
}

# A Pair Reader for POST method. Not sure if it handles GETs.
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
#Store the Pairs, check for duplicates
	if (defined($postpairs{$name})) {
	$postpairs{$name} = "$postpairs{$name}, $value";
	}
	else {
	$postpairs{$name} = $value;
	}

# A Debug Step for all PostPairs
#print "post - $name = $postpairs{$name}<br>\n";
}

if ($ENV{'REQUEST_METHOD'} eq "GET") {
getsome()
}
elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
postsome()
}
else {
dienice("CGI Request Method could not be determined.")
}
# ---------------
# Put your Code in the appropriate Subroutine.
# ---------------


sub getsome {
my($sub_input) = @_;
# ------------------------------------------------------------ GET SOME!!
dienice("GET method not allowed.");
# ------------------------------------------------------------ GET SOME!!
}

sub postsome {
my($sub_input) = @_;
# ----------------------------------------------------------- POST SOME!!

# The Mail Stuff

# Error Trap Some Inputs
if (exists($postpairs{'recipient'})) {$recipient = $postpairs{'recipient'}}
else {$recipient = "stale\@vectorstar.com"}

if (exists($postpairs{'homepage'})) {$homepage = $postpairs{'homepage'}}
else {$homepage = "http://stalemeat.vectorstar.net/"}

if (exists($postpairs{'subject'})) {$subject = $postpairs{'subject'}}
else {$subject = "Website Form Post"}

# Error Trapping of Inputs Done

$mailprog = '/usr/bin/sendmail';
open (MAIL, "|$mailprog -t") or dienice("Can't Access $mailprog!\n");
print MAIL <<EndOfMAIL;
To: $recipient
From: $postpairs{'email'} ($postpairs{'name'})
Reply-to: $postpairs{'email'} ($postpairs{'name'})
Subject: $subject

EndOfMAIL
# Now for the body of the Email

foreach $key (keys(%postpairs)) {

# Filter out System Input Pairs
 if (($key ne "recipient") && ($key ne "homepage") && ($key ne "subject")) {
        print MAIL "$key = $postpairs{$key}\n";
 }
}

close(MAIL);

# Finished Sending the Email. Now Return Some HTML.

print <<EndOfHTML;
<html><head><Title>Take It!</title></head>
<body bgcolor="#000000" text="#CCCCCC">
<center>
<h2>Thank You...</h2>
Thank you for writing. Your Email has been delivered.<p>
Return to my <a href="$homepage">home page</a>.
EndOfHTML
print "</body></html>";

# ----------------------------------------------------------- POST SOME!!
}

sub dienice {
my($errmsg) = @_;
print "<center><h2>Error</h2>\n";
print "$errmsg<br><br>\n";
print "</body></html>";
exit;
}

sub findreplace {
my($inpstr,$findstr,$replstr) = @_;
@results = grep(/$findstr/i,$replstr);
while ($#results >= 0) {
	$inpstr =~ s/$findstr/$replstr/;
	@results = grep(/$findstr/i,$replstr);}
	return $inpstr;
}
