#!/usr/bin/perl
require "lib/environment";
&loadenv(%ENV);
print "Content-type: text/html\n\n";

$uptime = `uptime`;
# testing with this... #$uptime =~ s/35/29/g;
chomp($uptime);
$uptime =~ s/  / /g;
$uptime =~ s/^ //g;
($time,$foo,$days,$foo,$hrsmins,$foo) = split(/ /i,$uptime);

if ($days >= 30) {
	$estimated_uptime = "100.00";
	$contiguous_uptime = "100.00";
} else {
	($hrs,$mins) = split(/:/i,$hrsmins);
	$count = $mins + (60 * $hrs) + (1440 * $days);
	$b = (43200 / $count) * 3;
	$a = (43200 - $b) / 432;

	if ($a >= 100) {
		$estimated_uptime = "100.00";
	} else {
		$estimated_uptime = substr($a,0,7);
	}

	$a = $count / 432;
	if ($a >= 100) {
		$contiguous_uptime = "100.00"; 
	} else {
		$contiguous_uptime = substr($a,0,7);
	}
}

$msg = "Estimated Uptime percentage for the last month: ".$estimated_uptime."%<br>\nContiguous Uptime percentage for the last month: ".$contiguous_uptime."%<br>\n";

# Template stuff
$foo = `cat data/uptime_template.html`;
$foo =~ s/__MSG__/$msg/g;
print $foo;
