<?
require("inc.config.php");
require("inc.auth.php");

if (authlevel($user) <= 0) {
 go_login("mail_filter.php");
}

if (isset($_POST[enabled]) && strlen($user) > 0) {
	# This must be an enable/disable call.
	$enabled = $_POST[enabled];

	$dbh = db_connect();
	$date = time();

	$BOUNCE = $_POST[BOUNCE];
	$DELIVER = $_POST[DELIVER];
	$REWRITE_SUBJ = $_POST[REWRITE_SUBJ];
	$SPAMFOLDER = sanitize($_POST[SPAMFOLDER]);
	$SPAMFOLDER = str_replace("..","",$SPAMFOLDER);
	$SPAMFOLDER = str_replace("/","",$SPAMFOLDER);
	$SPAMFOLDER = str_replace(",","",$SPAMFOLDER);

	$db_query = "INSERT INTO task_queue (account,assignedby,date,service,command) VALUES ('$user','$user','$date','mailfilter','BOUNCE=$BOUNCE,DELIVER=$DELIVER,REWRITE_SUBJ=$REWRITE_SUBJ,SPAMFOLDER=$SPAMFOLDER')";
	$sth = pg_query($dbh,$db_query);
	if (!$sth) {
	        $errormsg = pg_errormessage($dbh);
	        pg_close($dbh);
	        $mail_filter_page .= "<b>$errormsg</b>";
	}

	$db_query = "INSERT INTO task_queue (account,assignedby,date,service,command) VALUES ('$user','$user','$date','mailfilter','mailfilter=$enabled')";
	$sth = pg_query($dbh,$db_query);
	if (!$sth) {
	        $errormsg = pg_errormessage($dbh);
	        pg_close($dbh);
	        $mail_filter_page .= "<b>$errormsg</b>";
	} else {
	        $mail_filter_page .= "<br>Your mail filter will be ";
		if ($enabled == 1) {
			$mail_filter_page .= "enabled";
		} else {
			$mail_filter_page .= "disabled";
		}
		$mail_filter_page .= " and your mail configuration updated shortly. A system message will 
		be left for you when the changes have been made. 
		You can monitor your <a href=\"pending_tasks.php\">pending tasks</a>
		to see when the change is complete.";
	}
	pg_close($dbh);



} elseif (isset ($_POST[filterby0]) && strlen($user) > 0) {
	# This must be a rule change call.
	$newrules = array();
	$n = 0;
	$ftrick = "filterby".$n;

	while (isset($_POST[$ftrick]) == 1) {
		if ($_POST[$ftrick] != "") {
			$head = "";
			if ($_POST[$ftrick] == "Sender") {
				$head = "^From:.*";
			} elseif ($_POST[$ftrick] == "Subject") {
				$head = "^Subject:.*";
			}
			# add escape characters to filter. because of the
			# SQL command, they must be double-escaped.
			$txttrick = "text".$n;
			$tmprule = str_replace("\\","",$_POST[$txttrick]);
			$tmprule = str_replace("\$","\\\\\$",$tmprule);
			$tmprule = str_replace(".","\\\.",$tmprule);
			$tmprule = str_replace("*",".*",$tmprule);
			# This only has to be escaped once, for SQL.
			$tmprule = str_replace("'","\'",$tmprule);
			$newrule = $head.$tmprule;
			array_push($newrules, $newrule);
		# End if filterby is blank
		}
	$n++;
	$ftrick = "filterby".$n;
	#End while filters are yet to be translated
	}
	# Now that we've nicely written our rules to the newrules array,
	# it's time to write this crap to the db job queue.

	$dbh = db_connect();
	$date = time();
	$mailrules = implode("\n",$newrules)."\n";
	$db_query = "INSERT INTO task_queue (account,assignedby,date,service,command) VALUES ('$user','$user','$date','mailrules','mailrules=$mailrules')";
	$sth = pg_query($dbh,$db_query);
	if (!$sth) {
	        $errormsg = pg_errormessage($dbh);
	        pg_close($dbh);
	        $mail_filter_page .= "<b>$errormsg</b>";
	} else {
		$mail_filter_page .= " <br>Your mail rules will be updated shortly. A system message will 
		be left for you when the changes have been made. 
		You can monitor your <a href=\"pending_tasks.php\">pending tasks</a>
		to see when the change is complete.";
	}
	pg_close($dbh);
	
} else {
	# This must be a generic GET call.

$mail_filter_page = "
VectorStar's Mail Filtering system allows you to block email that you do not
want to receive. This is especially useful to block unsolicited spam mail! 
Click the question marks for more information.
<br><br>
";

#####
## Read the .qmail file to see if filtering is enabled.
#
$qmailfile = "/vsn/home/".$user."/.qmail";

if (is_file($qmailfile)) {
	$enabled = 1;
	$ENABLE_no = "";
	$ENABLE_yes = " selected";
} else {
	$enabled = 0;
	$ENABLE_no = " selected";
	$ENABLE_yes = "";
}

#####
## Read the .mailfilter.conf file to read current settings.
#
$conffile = "/vsn/home/".$user."/.mailfilter.conf";

if (is_file($conffile)) {
	# Read the conffile and set the default values!!
	$rawrules = file($conffile);
	for ($n = 0; $n < count($rawrules);$n++) {
		if (stristr($rawrules[$n],"=")) {
			$rawrule = split("=",$rawrules[$n]);
			$key = $rawrule[0];
			$value = rtrim(str_replace("\"","",$rawrule[1]));
			$config[$key] = $value;
		}
	}


	if ($config[BOUNCE]) {
		$BOUNCE_no = "";
		$BOUNCE_yes = " selected";
	} else {
		$BOUNCE_no = " selected";
		$BOUNCE_yes = "";
	}

	if ($config[DELIVER]) {
		$DELIVER_no = "";
		$DELIVER_yes = " selected";
	} else {
		$DELIVER_no = " selected";
		$DELIVER_yes = "";
	}

	if ($config[REWRITE_SUBJ]) {
		$REWRITE_SUBJ_no = "";
		$REWRITE_SUBJ_yes = " selected";
	} else {
		$REWRITE_SUBJ_no = " selected";
		$REWRITE_SUBJ_yes = "";
	}

} else {
	# Set the recommended default values?
	$DELIVER_no = "";
	$DELIVER_yes = " selected";
	$config[SPAMFOLDER]="INBOX";
}


$help = array();
$help[enable] = "With this setting, you can enable or disable mail filtering without losing your configuration or filter rules.";
$help[bounce] = "Bouncing spam mail means that the email is rejected and returned to the person who sent it.";
$help[deliver] = "Deliver will save a copy of the spam mail to the mail folder of your choice, even if you have chosen to bounce all spam messages.";
$help[mark] = "Marking messages as spam will add \'(SPAM)\' to the subject line of every detected spam message.";
$help[folder] = "This is the mail folder where all spam messages will be delivered. Choosing a folder other than your INBOX will keep your spam messages 
		 out of sight, but make sure you check and clear that spam folder from time to time. It will still take up disk space!";

$mail_filter_page .= "
<form method=\"POST\" action=\"mail_filter.php\">
<h3> Configuration: </h3>
<table class='vstable' style=\"width: 50%;\">

<tr><td valign=middle>
	<nobr>
	<b>Mail Filter Active</b>
	<a href=\"javascript:alert('$help[enable]')\">?</a>
</td><td>
	<nobr>
	<select name=\"enabled\">
	<option value=\"0\"$ENABLE_no>No
	<option value=\"1\"$ENABLE_yes>Yes
	</select>
</td></tr>

<tr><td valign=middle>
	<nobr>
	<b>Bounce spam back to sender</b>
	<a href=\"javascript:alert('$help[bounce]')\">?</a>
</td><td>
	<nobr>
	<select name=\"BOUNCE\">
	<option value=\"0\"$BOUNCE_no>No
	<option value=\"1\"$BOUNCE_yes>Yes
	</select>
</td></tr>

<tr><td valign=middle>
	<nobr>
	<b>Deliver spam to mailbox</b>
	<a href=\"javascript:alert('$help[deliver]')\">?</a>
</td><td>
	<select name=\"DELIVER\">
	<option value=\"0\"$DELIVER_no>No
	<option value=\"1\"$DELIVER_yes>Yes
	</select>
</td></tr>

<tr><td valign=middle>
	<b>Mark messages as spam</b>
	<a href=\"javascript:alert('$help[mark]')\">?</a>
</td><td>
	<select name=\"REWRITE_SUBJ\">
	<option value=\"0\"$REWRITE_SUBJ_no>No
	<option value=\"1\"$REWRITE_SUBJ_yes>Yes
	</select>
</td></tr>

<tr><td valign=middle>
	<b>Move spam to folder</b>
	<a href=\"javascript:alert('$help[folder]')\">?</a>
</td><td>
";

	$l1 = `ls -1 ~$user/.mail/`;
	$list = split("\n",$l1);
	$foldermenu = "<select name=\"SPAMFOLDER\">\n";
	for ($n = 0;$n < count($list);$n++) {
		$thisfolder = rtrim($list[$n]);
		if (strlen($thisfolder) >= 1) {
			$thisfolder == $config[SPAMFOLDER] ? $isselected = " selected" : $isselected = "";
			$foldermenu .= "<option$isselected>$thisfolder\n";
		}
	}
	$foldermenu .= "</select>\n";
	$mail_filter_page .= $foldermenu;

	$mail_filter_page .= "
</td></tr>

</table>
<br>
<input type=\"submit\" value=\"Update Configuration\">
</form><br>
";



#####
## Read the filtering rules for the user.
#
$mailrulesfile = "/vsn/home/".$user."/.mailrules";

if (is_file($mailrulesfile)) {
#Grab the contents of the mailrules file.
$mailrulesarray = file($mailrulesfile);
}
$filter_lines = count($mailrulesarray) + 5 + $_GET[boost];
$new_boost = $_GET[boost] + 5;
$mail_filter_page .= "

<table class='vstable'>
<tr><td>
<ul>
<li>To remove a filtering rule, change the <b>Filter By</b> column
to (blank).
<li>Special characters, such as: $ % ^ & ( ) [ ] { } | \ < > 
should <b>not</b> be used. Some of these characters may cause your filter to 
fail, thus blocking all mail to your mailbox.
<li>Safe characters are: ! @ * ? . , a-z A-Z 0-9 / ~ ' \" ; :
<li> <b>Note</b>: Using the wildcard <b>*</b> will allow for matching two 
strings with a gap of variable length inbetween them. It will not literally 
represent the character <b>*</b>.
<li> The filter is not case sensitive.
<li>You have 5 blank rules by default. If you want more, 
<a href=\"mail_filter.php?boost=$new_boost\">Click Here</a> to get 5 more blanks BEFORE you start writing your rules!
</ul>
</td></tr></table>


<form method=\"POST\" action=\"mail_filter.php\">
<h3>Your current filter Rules:</h3>
<table class='vstable' style=\"width: 10%\">
";

$help[filterby] = "There are three types of filter rules: Sender, Subject, or Message Text. A Message Text rule is all-encompassing and will search through the sender and subject as well.";
$help[filtertext] = "This is where you put the text that really defines each rule. If you make the rule too vague, many messages will be identified as spam.";

for ($n = 0; $n < $filter_lines; $n++) {
# Reset values for this iteration of the loop
	# Write the title row every (modulo) 10 lines.
	if (($n%10) == 0) {
		$mail_filter_page .= "<tr><td><b>Filter By</b>
		<a href=\"javascript:alert('$help[filterby]')\">?</a>
		</td><td><b>Filter Text</b>
		<a href=\"javascript:alert('$help[filtertext]')\">?</a>
		</td></tr>";
	}

	$optblank = "";
	$optsender = "";
	$optsubject = "";
	$optmessage = "";
	$rulevalue = "";
	if (isset($mailrulesarray[$n])) {
		$rule = rtrim($mailrulesarray[$n]);
		## Read the rule and figure out what type it is.

		$frompos = strpos($rule,"^From:");
		$subjpos = strpos($rule,"^Subject:");

		if (strlen($rule) == 0) {
			$optblank = " selected";
		} elseif (is_int($frompos) && $frompos == 0) {
			$optsender = " selected";
			$loc = strpos($rule,"*");
			$rulevalue = substr($rule,$loc + 1);
		} elseif (is_int($subjpos) && $subjpos == 0) {
			$optsubject = " selected";
			$loc = strpos($rule,"*");
			$rulevalue = substr($rule,$loc + 1);
### Filtering applies here too
		} else {
### All other rules are treated as message filter matches.
			$optmessage = " selected";
			$rulevalue = $rule;
		}
	# Once we reach this high count, add some blank lines.
	} else {
		$optblank = " selected";
		$optsender = "";
		$optsubject = "";
		$optmessage = "";
		$rulevalue = "";
	}

	# Remove backslashes from the rule.
	$rulevalue = str_replace("\\","",$rulevalue);
	# Turn .*'s to *'s
	$rulevalue = str_replace(".*","*",$rulevalue);

	#####
	## Actually print the result of this line to the page
	#
	$mail_filter_page .= "
	<tr><td>
		<select name=\"filterby$n\">
		<option$optblank>
		<option$optsender>Sender
		<option$optsubject>Subject
		<option$optmessage>Message
		</select>
	</td><td>
		<input type=\"text\" name=\"text$n\" size=30 value=\"$rulevalue\">
	</td></tr>";

#End for 1 to # of filter lines
}


#####
## Close up the page, we're done
#

$mail_filter_page .= "
</table>
<br>
<input type=\"submit\" value=\"Update Rules\">
</form>
</td></tr></table>
";

# End if post or get
}


$body = $mail_filter_page;

$pd = array(	user	=> "$user",
		page	=> "Mail Filtering",
		title	=> "Mail Filtering",
		body	=> "$body"
		);
write_page($pd);


?>
