<?
require("inc.config.php");
require("inc.auth.php");

if (authlevel($user) <= 0) {
 go_login("mailfilter.php");
}
if (isset($_POST[forwarding]) && strlen($user) > 0) {
	$in_fwdenab = $_POST[FWD_ENAB];
	$FWD_ADDR = $_POST[FWD_ADDR];
	$in_fwdenab == "on" ? $FWD_ENAB = 1 : $FWD_ENAB = 0;


	#####
	## Read the .qmail file to see if per-user bayesian filtering is enabled.
	#
	$qmailfile = "/vsn/home/".$user."/.qmail";
	if (is_file($qmailfile)) {
		$filecontents = file_get_contents($qmailfile);
		if (strpos($filecontents,"&") !== FALSE && $FWD_ENAB == 0) {
			# Disable forwarding
			$FWD_CHANGE = 1;
		} elseif (strpos($filecontents,"&") !== FALSE && $FWD_ENAB == 1) {
			# Check if the email address has changed.
			$startpos = strpos($filecontents,"&") + 1;
			strpos($filecontents,"\n",$startpos) !== FALSE ? $addrlen = strpos($filecontents,"\n",$startpos) - $startpos : $addrlen = strlen($filecontents) - $startpos;
			if ($FWD_ADDR != substr($filecontents,$startpos,$addrlen)) {
				# Change of fwd addr
				$FWD_CHANGE = 1;
			} else {
				# No change
				$FWD_CHANGE = 0;
			}
		} elseif (strpos($filecontents,"&") === FALSE && $FWD_ENAB == 1) {
			# Enable forwarding
			$FWD_CHANGE = 1;
		} else {
			$FWD_CHANGE = 0;
		}
	} #End if is_file(qmailfile)

	if ($FWD_CHANGE == 1) {
		$dbh = db_connect();
		$date = time();

		$db_query = "INSERT INTO task_queue (account,assignedby,date,service,command) VALUES ('$user','$user','$date','mailforward','FWD_ENAB=$FWD_ENAB,FWD_ADDR=$FWD_ADDR')";
		$sth = pg_query($dbh,$db_query);
		if (!$sth) {
		        $errormsg = pg_errormessage($dbh);
		        pg_close($dbh);
		        $mail_filter_page .= "<b>$errormsg</b>";
		} else {
			$FWD_ENAB == 0 ? $NOT = " <b>NOT</b>" : $NOT = "";
		        $mail_filter_page .= "<br>Your mail will$NOT be forwarded";
			if ($FWD_ENAB) {
				$mail_filter_page .= " to <b>$FWD_ADDR</b>.\n";
			} else {
				$mail_filter_page .= ".\n";
			}
			$mail_filter_page .= "
			<br>
			A system message will 
			be left for you when the changes have been made. 
			You can monitor your <a href=\"pending_tasks.php\">pending tasks</a>
			to see when the change is complete.";
			pg_close($dbh);
		}
	} else {
		$mail_filter_page .= "No changes made to mail forwarding settings.\n";
	} #End if fwd_change == 1

} elseif (isset($_POST[behavior]) && strlen($user) > 0) {
	# This must be a configuration change.
	$behavior = $_POST[behavior];
	$SPAMFOLDER = $_POST[SPAMFOLDER];
	$in_bayes = $_POST[bayes];
	$in_bayeslearn = $_POST[bayeslearn];

	$in_bayes == "on" ? $bayes = 1 : $bayes = 0;
	$in_bayeslearn == "on" ? $bayeslearn = 1 : $bayeslearn = 0;

	$dbh = db_connect();
	$date = time();

	$REWRITE_SUBJ = $_POST[REWRITE_SUBJ];
	$SPAMFOLDER = sanitize($_POST[SPAMFOLDER]);
	$SPAMFOLDER = str_replace("..","",$SPAMFOLDER);
	$SPAMFOLDER = str_replace("/","",$SPAMFOLDER);
	$SPAMFOLDER = str_replace(",","",$SPAMFOLDER);

	$db_query = "INSERT INTO task_queue (account,assignedby,date,service,command) VALUES ('$user','$user','$date','mailfilter','behavior=$behavior,SPAMFOLDER=$SPAMFOLDER,bayes=$bayes,bayeslearn=$bayeslearn')";
	$sth = pg_query($dbh,$db_query);
	if (!$sth) {
	        $errormsg = pg_errormessage($dbh);
	        pg_close($dbh);
	        $mail_filter_page .= "<b>$errormsg</b>";
	} else {

		$bayes == 1 ? $bayestxt = "turn on" : $bayestxt = "turn off";
		$bayeslearn == 1 ? $bayeslearntxt = "" : $bayeslearntxt = "do not ";

	        $mail_filter_page .= "<br>Your mail settings are: 
		<br>
		<table border=0><tr><td>
		<li><b>$behavior</b> spam messages
		<li>Your spamfolder is <b>$SPAMFOLDER</b>
		<li><b>$bayestxt</b> your bayesian filter
		<li><b>$bayeslearntxt</b>force re-training of the bayesian filter
		</td></tr></table>
		<br>
		A system message will 
		be left for you when the changes have been made. 
		You can monitor your <a href=\"pending_tasks.php\">pending tasks</a>
		to see when the change is complete.";
		pg_close($dbh);
	}

} elseif (isset ($_POST[filterby0]) && strlen($user) > 0) {
	# This must be a rule change call.
	$newrules = array();
	$n = 0;
	$ftrick = "filterby".$n;

	while (isset($_POST[$ftrick]) == 1) {
		if ($_POST[$ftrick] != "") {
			$head = "";
			if ($_POST[$ftrick] == "Sender") {
				$head = "^From:.*";
			} elseif ($_POST[$ftrick] == "Subject") {
				$head = "^Subject:.*";
			}
			# add escape characters to filter. because of the
			# SQL command, they must be double-escaped.
			$txttrick = "text".$n;
			$tmprule = str_replace("\\","",$_POST[$txttrick]);
			$tmprule = str_replace("\$","\\\\\$",$tmprule);
			$tmprule = str_replace(".","\\\.",$tmprule);
			$tmprule = str_replace("*",".*",$tmprule);
			# This only has to be escaped once, for SQL.
			$tmprule = str_replace("'","\'",$tmprule);
			$newrule = $head.$tmprule;
			array_push($newrules, $newrule);
		# End if filterby is blank
		}
	$n++;
	$ftrick = "filterby".$n;
	#End while filters are yet to be translated
	}
	# Now that we've nicely written our rules to the newrules array,
	# it's time to write this crap to the db job queue.

	$dbh = db_connect();
	$date = time();
	$mailrules = implode("\n",$newrules)."\n";
	$db_query = "INSERT INTO task_queue (account,assignedby,date,service,command) VALUES ('$user','$user','$date','mailrules','mailrules=$mailrules')";
	$sth = pg_query($dbh,$db_query);
	if (!$sth) {
	        $errormsg = pg_errormessage($dbh);
	        pg_close($dbh);
	        $mail_filter_page .= "<b>$errormsg</b>";
	} else {
		$mail_filter_page .= " <br>Your mail rules will be updated shortly. A system message will 
		be left for you when the changes have been made. 
		You can monitor your <a href=\"pending_tasks.php\">pending tasks</a>
		to see when the change is complete.";
		pg_close($dbh);
	}
} else {
	# This must be a generic GET call.

#####
## Read the .mailfilter.conf file to read current settings.
#
$conffile = "/vsn/home/".$user."/.mailfilter.conf";

if (is_file($conffile)) {
	# Read the conffile and set the default values!!
	$rawrules = file($conffile);
	for ($n = 0; $n < count($rawrules);$n++) {
		if (stristr($rawrules[$n],"=")) {
			$rawrule = split("=",$rawrules[$n]);
			$key = $rawrule[0];
			$value = rtrim(str_replace("\"","",$rawrule[1]));
			$config[$key] = $value;
		}
	}

	if (!isset($config[SPAMFOLDER])) {
		$config[SPAMFOLDER] = "spam";
	}

	if ($config[BOUNCE]) {
		$BOUNCE_ON = " checked";
	} elseif ($config[DELIVER]) {
		$DELIVER_ON = " checked";
	} else {
		$DELETE_ON = " checked";
	}

} else {
	# Set the recommended default values?
	$DELIVER_ON = " checked";
	$config[SPAMFOLDER]="spam";
}

#####
## Read the .qmail file to see if per-user bayesian filtering is enabled.
#
$qmailfile = "/vsn/home/".$user."/.qmail";
if (is_file($qmailfile)) {
	$filecontents = file_get_contents($qmailfile);
	if (strstr($filecontents,"spamc")) {
		$BAYES_CHECKED = " checked";
	} elseif (strpos($filecontents,"&") !== FALSE) {
		$FWDENAB_CHECKED = " checked";
		$startpos = strpos($filecontents,"&") + 1;
		strpos($filecontents,"\n",$startpos) !== FALSE ? $addrlen = strpos($filecontents,"\n",$startpos) - $startpos : $addrlen = strlen($filecontents) - $startpos;
		$FWD_ADDR = substr($filecontents,$startpos,$addrlen);
	}
}

$mail_filter_page .= "
<form method=\"POST\" action=\"mailfilter.php\">
<table class='vstable' style=\"width: 10%;\">

<tr><td valign=middle><nobr>
<input type='hidden' name='forwarding' value='1'>
<input type='checkbox' name='FWD_ENAB' $FWDENAB_CHECKED>
Forward all messages to the following email address:
<br>
<center>
<input type='text' name='FWD_ADDR' size=50 value='$FWD_ADDR'>
</center>

</nobr>
</td></tr>
</table>
<br>
<input type=\"submit\" value=\"Change Forwarding Setting\">
</form>

";

$help = array();
$help[bounce] = "Bouncing spam mail means that the email is rejected and returned to the person who sent it. If spammers receive a bounce message, they know that your mailbox exists, and they are more likely to keep sending you spam.";

$mail_filter_page .= "
<form method=\"POST\" action=\"mailfilter.php\">
<h3> What to do with spam messages: </h3>
<table class='vstable' style=\"width: 10%;\">

<tr><td valign=middle>
	<nobr>
	<input type='radio' name='behavior' value='deliver' $DELIVER_ON>
	Deliver messages to folder:
";
$l1 = `ls -1 ~$user/.mail/`;
$list = split("\n",$l1);
$foldermenu = "<select name=\"SPAMFOLDER\">\n";
for ($n = 0;$n < count($list);$n++) {
	$thisfolder = rtrim($list[$n]);
	if (strlen($thisfolder) >= 1) {
		$thisfolder == $config[SPAMFOLDER] ? $isselected = " selected" : $isselected = "";
		$foldermenu .= "<option$isselected>$thisfolder\n";
	}
}
$foldermenu .= "</select>\n";
$mail_filter_page .= $foldermenu;
$mail_filter_page .= "
	<br>
	<input type='radio' name='behavior' value='delete' $DELETE_ON>
	Delete messages
	<br>
	<input type='radio' name='behavior' value='bounce' $BOUNCE_ON>
	Bounce back to sender (<a href=\"javascript:alert('$help[bounce]')\">not recommended</a>)
	<br>
";

$mail_filter_page .= "
</td></tr>

</table>
<br>
";


$mail_filter_page .= "
<h3> Bayesian Filter: </h3>
<table class='vstable' style=\"width: 400;\">
<tr><td valign=middle>
	<ul>
	<nobr>
	<input type='checkbox' name='bayes' $BAYES_CHECKED>
	Enable personal bayesian filter
	</nobr>
	</ul>
	The bayesian filter automatically trains itself based on the messages
	sent to you. Only re-train if you are having trouble with messages being
	incorrectly classified.
	<ul>
	<nobr>
	<input type='checkbox' name='bayeslearn'>
	Re-train bayesian filter
	</nobr>
	</ul>
	<b>Retraining only works if you keep your good email in 'INBOX' and your
	bad email in 'spam'. If you do not keep your emails organized like this,
	retraining the filter is NOT recommended.</b>

</td></tr>
</table>
<br>
<input type=\"submit\" value=\"Update Configuration\">
</form><br>
";


#####
## Read the filtering rules for the user.
#
$mailrulesfile = "/vsn/home/".$user."/.mailrules";

if (is_file($mailrulesfile)) {
	#Grab the contents of the mailrules file.
	$mailrulesarray = file($mailrulesfile);
}
$filter_lines = count($mailrulesarray) + 10 + $_GET[boost];
$new_boost = $_GET[boost] + 10;
$mail_filter_page .= "

<h3> Keyword Filtering: </h3>
<table class='vstable'>
<tr><td>
This is the filter of last resort. SpamAssassin, especially with the bayesian
filter, should catch nearly everything. If there are still certain emails
that get past SpamAssassin, this filter can be used to stop them.
<br><br>
Here are some tips:
<ul>
<li>To remove a filtering rule, change the <b>Filter By</b> column
to (blank).
<li>Special characters, such as: $ % ^ & ( ) [ ] { } | \ < > 
should <b>not</b> be used. Some of these characters may cause your filter to 
fail, thus treating all messages as spam.
<li>Safe characters are: ! @ * ? . , a-z A-Z 0-9 / ~ ' \" ; :
<li> <b>Note</b>: Using the wildcard <b>*</b> will allow for matching two 
strings with a gap of variable length inbetween them. It will not literally 
represent the character <b>*</b>.
<li> The filter is not case sensitive.
<li>You have $GET[boost] 10 blank rule slots by default. If you want more, 
<a href=\"mailfilter.php?boost=$new_boost\">Click Here</a> to get 10 more 
blank slots.
</ul>
</td></tr></table>
<br>

<form method=\"POST\" action=\"mailfilter.php\">

<table class='vstable' style=\"width: 10%\">
";

$help[filterby] = "There are three types of filter rules: Sender, Subject, or Message Text. A Message Text rule is all-encompassing and will search through the sender and subject as well.";
$help[filtertext] = "This is where you put the text that really defines each rule. If you make the rule too vague, many messages will be identified as spam.";

for ($n = 0; $n < $filter_lines; $n++) {
# Reset values for this iteration of the loop
	# Write the title row every (modulo) 10 lines.
	if (($n%10) == 0) {
		$mail_filter_page .= "<tr><td><b>Filter By</b>
		<a href=\"javascript:alert('$help[filterby]')\">?</a>
		</td><td><b>Filter Text</b>
		<a href=\"javascript:alert('$help[filtertext]')\">?</a>
		</td></tr>";
	}

	$optblank = "";
	$optsender = "";
	$optsubject = "";
	$optmessage = "";
	$rulevalue = "";
	if (isset($mailrulesarray[$n])) {
		$rule = rtrim($mailrulesarray[$n]);
		## Read the rule and figure out what type it is.

		$frompos = strpos($rule,"^From:");
		$subjpos = strpos($rule,"^Subject:");

		if (strlen($rule) == 0) {
			$optblank = " selected";
		} elseif (is_int($frompos) && $frompos == 0) {
			$optsender = " selected";
			$loc = strpos($rule,"*");
			$rulevalue = substr($rule,$loc + 1);
		} elseif (is_int($subjpos) && $subjpos == 0) {
			$optsubject = " selected";
			$loc = strpos($rule,"*");
			$rulevalue = substr($rule,$loc + 1);
### Filtering applies here too
		} else {
### All other rules are treated as message filter matches.
			$optmessage = " selected";
			$rulevalue = $rule;
		}
	# Once we reach this high count, add some blank lines.
	} else {
		$optblank = " selected";
		$optsender = "";
		$optsubject = "";
		$optmessage = "";
		$rulevalue = "";
	}

	# Remove backslashes from the rule.
	$rulevalue = str_replace("\\","",$rulevalue);
	# Turn .*'s to *'s
	$rulevalue = str_replace(".*","*",$rulevalue);

	#####
	## Actually print the result of this line to the page
	#
	$mail_filter_page .= "
	<tr><td>
		<select name=\"filterby$n\">
		<option$optblank>
		<option$optsender>Sender
		<option$optsubject>Subject
		<option$optmessage>Message
		</select>
	</td><td>
		<input type=\"text\" name=\"text$n\" size=30 value=\"$rulevalue\">
	</td></tr>";

#End for 1 to # of filter lines
}


#####
## Close up the page, we're done
#

$mail_filter_page .= "
</table>
<br>
<input type=\"submit\" value=\"Update Keyword Filter\">
</form>
</td></tr></table>
";

# End if post or get
}


$body = $mail_filter_page;

$pd = array(	user	=> "$user",
		page	=> "Mail Filtering",
		title	=> "Mail Filtering",
		body	=> "$body"
		);
write_page($pd);


?>
