<?
require("inc.config.php");
require("inc.auth.php");

if (authlevel($user) <= 0) {
 go_login("pending_tasks.php");
}

$dbh = db_connect();

isset($_POST[cancel]) ? 	$cancel = sanitize($_POST[cancel]) :	$cancel = sanitize($_GET[cancel]);
isset($_POST[service]) ?	$service = sanitize($_POST[service]) :	$service = sanitize($_GET[service]);
isset($_POST[date]) ?		$date = sanitize($_POST[date]) :	$date = sanitize($_GET[date]);
isset($_POST[command]) ?	$command = myescape($_POST[command]) :	$command = myescape($_GET[command]);

$current_time = time();

if ($cancel == 1 && strlen($service) > 0 && $date > 0 && strlen($command) > 0) {
	$db_query = "SELECT account,service,command,date FROM task_queue WHERE 
		assignedby = '$user' AND service = '$service' AND command = '$command' AND date = '$date'";
	$sth = pg_query($dbh,$db_query);
	$numrows = pg_numrows($sth);
	if ($numrows >= 1) {
		$db_query = "DELETE FROM task_queue WHERE assignedby = '$user' AND service = '$service' AND command = '$command' AND date = '$date'";
		$sth = pg_query($dbh,$db_query);
		$notification = "Task Deleted.";
	} else {
		$notification = "Could not delete task! It may have already been run.";
	}
}

if (strlen($notification) > 0) {
	$body .= "<font color=\"red\">$notification</font><br><br>\n";
}


$db_query = "SELECT account,service,command,date FROM task_queue WHERE assignedby = '$user'";
$sth = pg_query($dbh,$db_query);
$numrows = pg_numrows($sth);
if ($numrows > 0) {
	$body .= "<table class='vstable'>
		<tr bgcolor='#333366'><td>Date</td><td>Service</td><td>Command</td><td><nobr>Cancel Task?</nobr></td></tr>\n";
}
for ($n = 0;$n < $numrows;$n++) {
	$result = pg_fetch_row($sth,$n);
	$account = $result[0];
	$service = $result[1];
	$command = $result[2];
	$date = $result[3];
	$pdate = strftime("%b %d %H:%M",$date);
	$opts = "<form method='POST' action='pending_tasks.php'>
		<input type='hidden' name='cancel' value='1'>
		<input type='hidden' name='service' value='$service'>
		<input type='hidden' name='date' value='$date'>
		<input type='hidden' name='command' value='$command'>
		<input type='submit' value='Cancel'>
		</form>";
	#### Might want to add a "reschedule" option in the future.

	$action = $command;
	# If this is a standard feature line, tailor the "command" output to match.
	if (ereg("feature-",$service)) {
		$tmparray = explode(",",$command);
		foreach ($tmparray as $linenum => $line) {
			if ($line == "enabled=t") {
				$action = "Enable,";
			} elseif ($line == "enabled=f") {
				$action = "Disable";
			}
			if (ereg("config=",$line) && $action == "Enable,") {
				$config = ereg_replace("config=","",$line);
				$action .= " Config: <i>$config</i>";
			}
		}
	} elseif (ereg("passwd",$service)) {
		$action = "Change password";
	} elseif (ereg("mailfilter",$service)) {
		$action = "Update mail settings";
	} elseif (ereg("mailrules",$service)) {
		$action = "Update mail filtering rules";
	} elseif (ereg("delete",$service)) {
		$action = "Delete account";
	}
	if ($account != $user) {
		$action .= " <b>for user '$account'</b>";
	}

	# Cute little dividing line.
	$body .= "<tr bgcolor='#666699'><td colspan=4></td></tr>";
	$body .= "\t\t<tr><td><nobr>$pdate</nobr></td><td><font color=\"#9999CC\">$service</font></td><td>$action</td><td>$opts</td>\n";
}
if ($numrows == 0) {
	$body .= "You have no pending tasks.\n";
} else {
	$body .= "</table>";
}

pg_close($dbh);

$pd = array(	user	=> "$user",
		page	=> "Pending Tasks",
		title	=> "Pending Tasks",
		body	=> "$body"
		);
write_page($pd);

?>
