<?
require("inc.config.php");
require("inc.auth.php");

$dbh = db_connect();

$CONT_BUTTON_TXT = ">> Continue";

isset($_POST[sessionid]) ? $sessionid = sanitize($_POST[sessionid]) : $sessionid = rand(1,32767);
isset($_POST[step]) ? $step = sanitize($_POST[step]) : $step = 1;
$client_ip = $_SERVER[REMOTE_ADDR];

if (isset($_GET[flush]) && $_GET[flush] == "yes") {
	$sessionid = sanitize($_GET[sessionid]);

	$db_query = "DELETE FROM signups_temp WHERE last_known_ip = '$client_ip' AND sessionid = '$sessionid'";
	$sth = pg_query($dbh,$db_query);
}


$body = "
	<form method='POST' action='signup.php'>
	<table class='vstable'>
	<tr><td>
";

# Here go the steps (in reverse order)

if ($step == 7) {
	# No expected variables in this step. Just take the data and move it to the final table.

	$db_query = "SELECT username,realname,reference_email,features,referredby FROM signups_temp WHERE last_known_ip = '$client_ip' AND sessionid = '$sessionid'";
	$sth = pg_query($dbh,$db_query);
	if ($numrows > 1) {
		flush_signup();
		exit;
	}
	$result = pg_fetch_row($sth,0);
	$username = $result[0];
	$realname = $result[1];
	$reference_email = $result[2];
	$features = $result[3];
	$referredby = $result[4];
	$signup_date = time();
	$last_known_ip = $client_ip;


	if (strlen($username) > 0) {
		$db_query = "INSERT INTO signups (username,realname,reference_email,features,referredby,last_known_ip,signup_date)
		VALUES('$username','$realname','$reference_email','$features','$referredby','$last_known_ip','$signup_date')";
		$sth = pg_query($dbh,$db_query);
		if ($sth == FALSE) {
			flush_signup();
			exit;
		}
		$db_query = "DELETE FROM signups_temp WHERE last_known_ip = '$client_ip' AND sessionid = '$sessionid'";
		$sth = pg_query($dbh,$db_query);
		# Also update the referral table.
		$db_query = "UPDATE referrals SET status = 'pending' WHERE email_address = '$reference_email'";
		$sth = pg_query($dbh,$db_query);

		$step = "Done!";

		$body .= "
			<center>
			Your signup request is complete! If your signup request is approved, you will receive an email confirming
			your account information.
			<br><br>
			If you haven't read the Info/Help pages yet, please read them now!
			</center>
		";
	} else {
		flush_signup();
		exit;
	};
} #End if step 7

if ($step == 6) {
	# Expected variables in this step:
	#  feature_mail
	#  feature_web
	#  feature_web_domain
	#  web_domain
	# checkbox is blank for off, "on" for on.
	$_POST[feature_mail] == "on" ? $feature_mail = 1 : $feature_mail = 0;
	$_POST[feature_web] == "on" ? $feature_web = 1 : $feature_web = 0;
	$_POST[feature_web_domain] == "on" ? $feature_web_domain = 1 : $feature_web_domain = 0;
	isset($_POST[web_domain]) && strlen($_POST[web_domain]) > 0 ? $web_domain = sanitize($_POST[web_domain].".vectorstar.net") : $web_domain = "";

	$features = "";
	if ($feature_mail) {
		$features .= ",mail=1";
	}
	if ($feature_web) {
		$features .= ",web=1";
	}
	if ($feature_web && $feature_web_domain) {
		if (!is_valid_web_domain($web_domain)) {
			$body .= write_error("The web domain you entered is either in use or invalid. Please try again.");
			$step--;
		} else {
			$features .= ",web_domain=$web_domain";
		}
	}

	# Sanity checks complete - keep going
	if ($step == 6) {
		$features = ereg_replace("^\,","",$features);

		$db_query = "UPDATE signups_temp SET features = '$features' WHERE last_known_ip = '$client_ip' AND sessionid = '$sessionid'";
		$sth = pg_query($dbh,$db_query);

		$db_query = "SELECT username,realname,reference_email,features,referredby FROM signups_temp WHERE last_known_ip = '$client_ip' AND sessionid = '$sessionid'";
		$sth = pg_query($dbh,$db_query);
		if ($numrows > 1) {
			flush_signup();
			exit;
		}
		$result = pg_fetch_row($sth,0);
		$username = $result[0];
		$realname = $result[1];
		$reference_email = $result[2];
		$referredby = $result[4];

		$feature_explaination = "";
		if ($feature_mail) {
		$feature_explaination .= "Email (<i>$username@vectorstar.net</i>)<br>\n";
		}
		if ($feature_web) {
			$feature_explaination .= "Webpage (<i>http://users.vectorstar.net/~$username/</i>)<br>\n";
		}
		if ($feature_web && $feature_web_domain) {
			$feature_explaination .= "Web Domain (<i>http://$web_domain/</i>)<br>\n";
		}



		$body .= "
			<center>
			<h2>Please review your selection:</h2>
			<table>
			<tr><td><b>Username:</b> </td><td>$username</td></tr>
			<tr><td><b>Real Name:</b> </td><td>$realname</td></tr>
			<tr><td><b>Email Address:</b> </td><td>$reference_email</td></tr>
			<tr><td><b>Features:</b> </td><td>$feature_explaination</td></tr>
			<tr><td><b>Referred By:</b> </td><td>$referredby</td></tr>
			</table>
			<br>
			If this is correct, click on Finish.
			<br>
			If this is incorrect, <a href='signup.php?sessionid=$sessionid&flush=yes'>click here</a> to try again.
			</center>
			<br><br>
		";
		$CONT_BUTTON_TXT = ">> Finish";
	}
} #End step 6

if ($step == 5) {
	# Expected variables in this step:
	#  realname
	#  reference_email
	isset($_POST[realname]) ? $realname = sanitize($_POST[realname]) : $username = "";
	isset($_POST[reference_email]) ? $reference_email = sanitize($_POST[reference_email]) : $username = "";

	$db_query = "SELECT realname FROM signups_temp WHERE last_known_ip = '$client_ip' AND sessionid = '$sessionid'";
	$sth = pg_query($dbh,$db_query);
	$numrows = pg_numrows($sth);
	if ($numrows > 1) {
		flush_signup();
		exit;
	}
	$result = pg_fetch_row($sth,0);
	if (strlen($result[0]) > 1) { $realname = $result[0]; }

	$db_query = "SELECT reference_email FROM signups_temp WHERE last_known_ip = '$client_ip' AND sessionid = '$sessionid'";
	$sth = pg_query($dbh,$db_query);
	$numrows = pg_numrows($sth);
	if ($numrows > 1) {
		flush_signup();
		exit;
	}
	$result = pg_fetch_row($sth,0);
	if (strlen($result[0]) > 1 && strlen($reference_email) == 0) { $reference_email = $result[0]; }

	if (!preg_match("/ /",$realname) || strlen($realname) < 5) {
		$body .= write_error("Please provide both your first and last name.");
		$step--;
	} else {
		$db_query = "UPDATE signups_temp SET realname = '$realname' WHERE last_known_ip = '$client_ip' AND sessionid = '$sessionid'";
		$sth = pg_query($dbh,$db_query);
	}

	$result = is_valid_email_addr($reference_email);
	if (!$result[0] && $step == 5) {
		$body .= write_error("$result[1]");
		$step--;
	} else {
		$db_query = "UPDATE signups_temp SET reference_email = '$reference_email' WHERE last_known_ip = '$client_ip' AND sessionid = '$sessionid'";
		$sth = pg_query($dbh,$db_query);	
	}
	# Check to see if this email addr is in the referral list.
	$db_query = "SELECT referredby FROM referrals WHERE email_address = '$reference_email'";
	$sth = pg_query($dbh,$db_query);
	$numrows = pg_numrows($sth);
	if ($step == 5) {
		if ($numrows <= 0) {
			$body .= write_error("Sorry, but based on your email address, it appears that no one has referred you to VectorStar. You must be referred by an existing senior member in order to create an account.");
			$step--;
		} else {
			$result = pg_fetch_row($sth,0);
			$referredby = $result[0];
			$db_query = "UPDATE signups_temp SET referredby = '$referredby' WHERE last_known_ip = '$client_ip' AND sessionid = '$sessionid'";
			$sth = pg_query($dbh,$db_query);
		}
	}
# LAIRD

	# Sanity checks done - Keep going.
	if ($step == 5) {

	$db_query = "SELECT username FROM signups_temp WHERE last_known_ip = '$client_ip' AND sessionid = '$sessionid'";
	$sth = pg_query($dbh,$db_query);
	$result = pg_fetch_row($sth,0);
	$username = $result[0];

		$body .= "
			<center>
			Choose the services you wish to use:
			<table><tr><td>
			<input type='checkbox' name='feature_mail'>
			<b>Email</b>
			 (<i>$username@vectorstar.net</i>)
			<br>
			<input type='checkbox' name='feature_web'>
			<b>Web Site</b>
			 (<i>http://users.vectorstar.net/~$username/</i>)
			<ul>
			<input type='checkbox' name='feature_web_domain'>
			<b>Virtual Domain</b>
			 (<i>http://<input type='text' name='web_domain' value='$username' size=16 maxlength=32>.vectorstar.net/</i>)
			</ul>
			</td></tr></table>
			</center>
		";
	} #End if
} #End step 5.


if ($step == 4) {
	# Expected variables in this step:
	#  username
	isset($_POST[username]) ? $username = sanitize($_POST[username]) : $username = "";

	$db_query = "SELECT username FROM signups_temp WHERE last_known_ip = '$client_ip' AND sessionid = '$sessionid'";
	$sth = pg_query($dbh,$db_query);
	$numrows = pg_numrows($sth);
	if ($numrows > 1) {
		flush_signup();
		exit;
	}
	$result = pg_fetch_row($sth,0);
	if (strlen($result[0]) > 1) { $username = $result[0]; }

	if (strlen($username) < 2) {
		$body .= write_error("Usernames must be at least 2 characters long. Choose a longer username.");
		$step--;
	} elseif (strlen($username) > 16) {
		$body .= write_error("Usernames can not be longer than 16 characters. Choose a shorter username.");
		$step--;
	} elseif (user_exists($username)) {
		$body .= write_error("A user with that name already exists. Please choose another username.");
		$step--;
	} elseif (signup_exists($username)) {
		$body .= write_error("A signup is currently pending for this username. Please choose another username.");
		$step--;
	} elseif (is_banned("username",$username)) {
		$body .= write_error("That username is not permitted on our system. Please choose another username.");
		$step--;
	} elseif (is_numeric(substr($username,0,1))) {
		$body .= write_error("Usernames must begin with a letter, not a number.");
		$step--;
	} elseif (!is_valid_username($username)) {
		$body .= write_error("Usernames may only contain lowercase letters (a-z) and numbers (0-9). No capital letters or special characters are allowed.");
		$step--;
	} elseif (`grep "^$username:" /etc/passwd` != "") {
		error_log("RED ALERT: Person at IP $client_ip tried to sign up for username of $username . Records show that username exists in the password file but not in the database!");
		$body .= write_error("A user with that name already exists. Please choose another username.");
		$step--;
	}
	# Sanity checks done - Keep going.
	if ($step == 4) {
		$db_query = "UPDATE signups_temp SET username = '$username' WHERE last_known_ip = '$client_ip' AND sessionid = '$sessionid'";
		$sth = pg_query($dbh,$db_query);
	
		$body .= "
			<center>
			What is your <b>REAL</b> name (first and last)? <br>
			<b>Name:</b> <input type='text' name='realname' size=32 maxlength=255 value=\"$realname\">
			<br><br>
			Please provide an ISP email address (free mail services not accepted) where we can contact you. This address will be used for account verification.<br>
			<b>Email:</b> <input type='text' name='reference_email' size=48 maxlength=255 value=\"$reference_email\">
			<br><br>
			</center>
		";
	} #End if
} #End step 4

if ($step == 3) {
	# Expected variables in this step:
	#  agree
	# checkbox is blank for off, "on" for on.
	$_POST[agree] == "on" ? $agree = 1 : $agree = 0;

	$db_query = "SELECT agree FROM signups_temp WHERE last_known_ip = '$client_ip' AND sessionid = '$sessionid'";
	$sth = pg_query($dbh,$db_query);
######
	if (!$sth) {
		$body .= "$db_query<br>".pg_result_error($sth)."<br>";
	}

	$numrows = pg_numrows($sth);
	if ($numrows > 1) {
		flush_signup();
		exit;
	}
	$result = pg_fetch_row($sth,0);
	if ($result[0] == TRUE) { $agree = 1; }

	if ($agree == 0) {
		$body .= write_error("You must read and agree to the rules before you can continue.");
		$step--;
		
	}
	# Sanity checks done - Keep going.
	if ($step == 3) {
		$db_query = "UPDATE signups_temp SET agree = '$agree' WHERE last_known_ip = '$client_ip' AND sessionid = '$sessionid'";
		$sth = pg_query($dbh,$db_query);

		$body .= "
		<br><center>
		Please choose your username. It must be at least 2 characters long and no more than 16 characters.
		<br><br>
		<b>Username: </b><input type='text' name='username' size='16' maxlength='16' value=\"$username\">
		<br><br>
		</center>
		";
	} #End if
} #End step 3
if ($step == 2) {
	# Check to make sure that this sessionid exists in the temp table.
	$db_query = "SELECT sessionid FROM signups_temp WHERE last_known_ip = '$client_ip' AND sessionid = '$sessionid'";
	$sth = pg_query($dbh,$db_query);
	$numrows = pg_numrows($sth);
	if ($numrows > 1) {
		flush_signup();
		exit;
	} elseif ($numrows == 0) {
		$step--;
	} elseif (is_banned("ip_address",$client_ip)) {
		$body .= write_error("You are not allowed to sign up for a VectorStar account because of prior network abuse from your IP.");
		$step--;
	}
	# Sanity checks done - Keep going.
	if ($step == 2) {
		$body .= file_get_contents("info/rules.dat");
		$body .= "<br><input type='checkbox' name='agree'> Yes, I understand 
		these rules and will abide by them.";
	} #End if
} #End step 2
if ($step == 1) {
	$body .= "
	So you're interested in getting an account at VectorStar? If you 
	haven't read our <a href='/info/' target='_new'>Info/Help pages</a> 
	yet, I recommend reading through them before we begin.
	<br><br>
	Accounts do not get immediately created - They must be approved by
	the staff. Please do not sign up multiple times, as all of your
	requested accounts will be denied.
	<br><br>
	During this signup process, you will be asked for some personal 
	information. This information MUST be accurate. It will only used to 
	identify and/or contact you regarding your account. We do not 
	advertise, send out newsletters, sell or share your information with 
	third parties. However, we are extremely strict about being given 
	accurate and complete information. <b>If you do not provide accurate 
	information, your account request will not be approved.</b>
	<br><br>
	Well, let's get started!
	";
	$db_query = "SELECT sessionid FROM signups_temp WHERE last_known_ip = '$client_ip' AND sessionid = '$sessionid'";
	$sth = pg_query($dbh,$db_query);
	$numrows = pg_numrows($sth);
	if ($numrows == 0) {
		$db_query = "INSERT INTO signups_temp (last_known_ip,sessionid,step) VALUES('$client_ip','$sessionid','$step')";
		$sth = pg_query($dbh,$db_query);
	}
} #End step 1

# Update the db to know what step we're on.
	$db_query = "UPDATE signups_temp SET step = '$step' WHERE last_known_ip = '$client_ip' AND sessionid = '$sessionid'";
	$sth = pg_query($dbh,$db_query);

$step_next = $step + 1;
$body .= "

	</td></tr>
	</table>
	<input type='hidden' name='sessionid' value='$sessionid'>
	<input type='hidden' name='step' value='$step_next'>
";
if (is_numeric($step)) {
	$body .= "	<input type='submit' value='$CONT_BUTTON_TXT'>";
	$titlestr = "step $step";
} else {
	$titlestr = "$step";
}
$body .= "
	</form>
";

pg_close($dbh);

$pd = array(	user	=> "$user",
		page	=> "Signup",
		title	=> "Signup - $titlestr",
		body	=> $body
		);
write_page($pd);


function write_error($errmsg) {
	return "<br><h3 align=center><font color='red'><i>$errmsg</i></font></h3>\n";
}

function flush_signup() {
		echo "<html><h2 align=center>A major error has occurred</h2>\n\t<h3>The system has lost track of your signup information and you will have to restart the signup process. Please <a href='signup.php'>click here to try again.</a></h3></html>";
		$db_query = "DELETE FROM signups_temp WHERE last_known_ip = '$client_ip' AND sessionid = '$sessionid'";
		$sth = pg_query($dbh,$db_query);
}

?>
