<?
require("inc.config.php");
require("inc.auth.php");

if (authlevel($user) <= 0) {
 go_login("webstats.php");
}

if (authlevel($user) == 7) {
	if (isset($_GET[username])) {
		$username = sanitize($_GET[username]);
	} elseif (isset($_GET[domain])) {
		$domain = sanitize($_GET[domain]);
	} else {
		# Give them a list of websites with stats to show.
		$dbh = db_connect();
		$db_query = "SELECT username,config FROM features WHERE feature = 'web_domain' AND enabled = 't'";
		$sth = pg_query($dbh,$db_query);
		$numrows = pg_numrows($sth);
		for ($n = 0;$n < $numrows;$n++) {
			$result = pg_fetch_row($sth,$n);
			$db_username = $result[0];
			$db_domain = $result[1];
			$owner[$db_domain] = $db_username;
		}

		$domain_list = trim(`ls -1 /vsn/web/admin.vectorstar.net/stats/*.html`);
		$domains_array = explode("\n",$domain_list);
		sort($domains_array);
		$body .= "<table><tr><td>";
		foreach ($domains_array as $domain) {
			$domain = ereg_replace("/vsn/web/admin.vectorstar.net/stats/","",$domain);
			$domain = ereg_replace(".html","",$domain);

			$body .= "<a href='webstats.php?domain=$domain'>$domain</a> - $owner[$domain]<br>\n";
		}
		$body .= "</td></tr></table>\n";
		unset($domain);
	}
} else {
	# Set the user to self.
	$username = $user;
}

if (isset($username) &&  strlen($username) > 1) {
	$dbh = db_connect();
	$db_query = "SELECT config FROM features WHERE feature = 'web_domain' AND enabled = 't' AND username = '$username'";
	$sth = pg_query($dbh,$db_query);
	$result = pg_fetch_row($sth,0);
	$domain = $result[0];
}

if (isset($domain) && strlen($domain) > 1) {
	if (file_exists("/vsn/web/admin.vectorstar.net/stats/$domain.html")) {
		$body .= "<table><tr><td>".`cat /vsn/web/admin.vectorstar.net/stats/$domain.html`."</td></tr></table>";
	} else {
		$body .= "Sorry, web stats for domain <b>$domain</b> were not found.";
	}
} else {
	$body .= "You must have a virtual domain in order to have web stats calculated.";
}

$pd = array(	user	=> "$user",
		page	=> "Website Stats",
		title	=> "",
		body	=> "$body"
		);
write_page($pd);

?>
