<?
require("inc.config.php");
require("inc.auth.php");

if (authlevel($user) != 7) {
	# Some non-staff asshole is trying to get up in this bitch
	Header("Location: index.php");
	exit;
}
#####
## Variables
$USERS_PER_PAGE = 25;

#####
## variables for handling approvals
# $page - which page to display
# $approve = list of usernames to approve
# $deny = list of usernames to deny
#
isset($_POST[page]) ? $page = $_POST[page] : $page = $_GET[page];
isset($_GET[page]) ? $page = $_GET[page] : $page = 1;
$dbh = db_connect();

if (isset($_POST[page])) {
	# Let's execute the changes based on the data provided.

	while (!is_null($key = key($_POST))) {
		if ($_POST[$key] == "approve") {
			$approvals[] = $key;
			$return = user_approve(sanitize($key));
			if ($return != 0) {
				$page_head .= "ERROR on user $user: $return<br>\n";
			}
		} elseif ($_POST[$key] == "deny") {
			$denials[] = $key;
			$return = user_deny(sanitize($key));
			if ($return != 0) {
				$page_head .= "ERROR on user $user: $return<br>\n";
			}
		}
	next($_POST);
	}

	#Display who has been approved and denied.
	$page_head .= "<table cellpadding=10><tr><td align=center>\n";
		# Do the approvals table.
		$page_head .= "<table>
		<tr bgcolor='#333366'><td>Users Approved:</td></tr>\n";
		for ($n = 0;$n < count($approvals);$n++) {
			if (is_int($n/2)) {
				$page_head .= "<tr bgcolor=\"#000000\"><td>$approvals[$n]</td></tr>\n";
			} else {
				$page_head .= "<tr bgcolor=\"#181818\"><td>$approvals[$n]</td></tr>\n";
			}
		}
		$page_head .= "</table>\n";
	$page_head .= "</td><td align=center>\n";
		# Do the denials table.
		$page_head .= "<table>
		<tr bgcolor='#333366'><td>Users Denied:</td></tr>\n";
		for ($n = 0;$n < count($denials);$n++) {
			if (is_int($n/2)) {
				$page_head .= "<tr bgcolor=\"#000000\"><td>$denials[$n]</td></tr>\n";
			} else {
				$page_head .= "<tr bgcolor=\"#181818\"><td>$denials[$n]</td></tr>\n";
			}
		}
		$page_head .= "</table>\n";
	$page_head .= "</td></tr></table><br><br>\n";
} #End if it's a POST execution..

$db_query = "SELECT username,realname,reference_email,last_known_ip,features,signup_date,referredby FROM signups ORDER BY signup_date";
$db_query = "SELECT username,realname,reference_email,last_known_ip,features,signup_date,referredby FROM signups ORDER BY last_known_ip";
$sth = pg_query($dbh,$db_query);
$numrows = pg_numrows($sth);

# Skip-to-page feature:
$numpages = $numrows / $USERS_PER_PAGE;
if (!is_int($numpages)) {
	$numpages++;
}

if ($numrows > 0) {
	$page_head .= "Skip to page: ";
	for ($n = 1; $n <= $numpages;$n++) {
		if ($n == $page) {
			$page_head .= " $n ";
		} else {
			$page_head .= " <a href=\"admin_approve.php?page=$n\">$n</a> ";
		}
	}
	
	$page_head .= "
	<form method='POST' action='admin_approve.php'>
	<input type='hidden' name='page' value='$page'>
	<table border=0>
	<tr bgcolor=\"#333366\">
	<td>Action</td>
	<td>Username</td>
	<td>Referred By</td>
	<td>Real Name / Reference Email</td>
	<td>IP Address</td>
	<td>Features</td>
	<td>Signup Date</td>
	</tr>
	";
} else {
	$page_head .= "There are currently no signups pending approval.";
} #End if $numrows

$start = $page * $USERS_PER_PAGE - $USERS_PER_PAGE;
if ($numrows - $start < $USERS_PER_PAGE) {
	$count = $numrows - $start;
} else {
	$count = $USERS_PER_PAGE;
}

for ($n = $start;$n < $count + $start;$n++) {
	$result = pg_fetch_row($sth,$n);
	$username = $result[0];
	$realname = $result[1];
	$reference_email = $result[2];
	$last_known_ip = $result[3];
	$features = $result[4];
	$signup_date = $result[5];
	$referredby = $result[6];

	# Query the number of duplicate IP's in the system
	$test_ip = substr($last_known_ip,0,strlen($last_known_ip) - 2);
	$db_query = "SELECT username FROM users WHERE last_known_ip LIKE '$test_ip%'";
	$sth2 = pg_query($dbh,$db_query);
	$numdups = pg_numrows($sth2);
	if ($numdups > 0) {
		$duplist = ": ";
		for ($i = 0; $i < $numdups;$i++) {
			$thisresult = pg_fetch_row($sth2,$i);
			$duplist .= " <a href='admin_edituser.php?username=$thisresult[0]' target='_new'>$thisresult[0]</a>";
		}
	} else {
		$duplist = "";
	}

	$n_signup_date = nice_time($signup_date);

	if (is_int($n/2)) {
		$page_body .= "<tr bgcolor=\"#000000\">\n";
	} else {
		$page_body .= "<tr bgcolor=\"#181818\">\n";
	}
	$page_body .= "
	<td><nobr><input type='radio' name='$username' value='approve'>Approve
	<br><input type='radio' name='$username' value='deny'>Deny</nobr></td>
	<td>$username</td>
	<td><a href='admin_edituser.php?username=$referredby' target='_new'>$referredby</a></td>
	<td>$realname (<font style=\"font-size: small\"><a href=\"mailto:$reference_email\">$reference_email</a></font>)</td>
	<td><b>$last_known_ip</b> ($numdups duplicates$duplist)</td>
	<td>$features</td>
	<td>$n_signup_date</td>
	</tr>";

} #End for each user

$page_foot = "</table>
<input type='submit' value='Approve/Deny Users'>
</form>
";

$body = $page_head.$page_body.$page_foot;

pg_close($dbh);

$pd = array(	user	=> "$user",
		page	=> "admin- approve users",
		title	=> "Admin: Approve Users",
		body	=> $body
		); # End of array for page display
write_page($pd);

### Functions

function user_approve($user) {
	# Retrieve the goods.
	$dbh = db_connect();
	$db_query = "SELECT realname,reference_email,last_known_ip,features,signup_date,referredby FROM signups WHERE username = '$user'";
	$sth = pg_query($dbh,$db_query);
	$numrows = pg_numrows($sth);
	if ($numrows != 1) {
		return 255;
	}
	$result = pg_fetch_row($sth);
	$realname = $result[0];
	$reference_email = $result[1];
	$last_known_ip = $result[2];
	$features = $result[3];
	$signup_date = $result[4];
	$referredby = $result[5];

	$approval_date = time();

	#Add them to the approved list.
	$db_query = "INSERT INTO signups_approved (username,realname,reference_email,last_known_ip,features,signup_date,approval_date,referredby) 
	VALUES('$user','$realname','$reference_email','$last_known_ip','$features','$signup_date','$approval_date','$referredby')";
	$sth = pg_query($dbh,$db_query);
	if (pg_affected_rows($sth) != 1) {
		return 254;
	}

	# Update the referral table (don't forcibly check for success)
	$db_query = "SELECT reference_email FROM signups WHERE username = '$user'";
	$sth = pg_query($dbh,$db_query);
	$result = pg_fetch_row($sth,0);
	$db_query = "UPDATE referrals SET status = 'approved' WHERE email_address = '$result[0]'";
	$sth = pg_query($dbh,$db_query);

	# Delete the account from the list.
	$db_query = "DELETE FROM signups WHERE username='$user'";
	$sth = pg_query($dbh,$db_query);
	if (pg_affected_rows($sth) != 1) {
		return 253;
	}
return 0;
} #End function user_approve.

function user_deny($user) {
	# Delete the account from the list.
	$dbh = db_connect();

	# Update the referral table (don't forcibly check for success)
	$db_query = "SELECT reference_email FROM signups WHERE username = '$user'";
	$sth = pg_query($dbh,$db_query);
	$result = pg_fetch_row($sth,0);
	$db_query = "UPDATE referrals SET status = 'denied' WHERE email_address = '$result[0]'";
	$sth = pg_query($dbh,$db_query);

	$db_query = "DELETE FROM signups WHERE username='$user'";
	$sth = pg_query($dbh,$db_query);
	if (pg_affected_rows($sth) != 1) {
		return 253;
	}

return 0;
}


?>
