<?
require("inc.config.php");
require("inc.auth.php");

if (authlevel($user) != 7) {
	# Some non-staff asshole is trying to get up in this bitch
	Header("Location: index.php");
	exit;
}
#####
## Username is a required variable for this script...
##

if (!isset($_POST[username])) {
	Header("Location: admin_userlist.php");
	exit;
} elseif (isset($_POST[username])) {
	$username = sanitize($_POST[username]);
}

#####
## Validate the following input variables:
##
isset($_POST[realname]) ? $realname = sanitize($_POST[realname]) : $realname = "";
isset($_POST[reference_email]) ? $reference_email = sanitize($_POST[reference_email]) : $reference_email = "";

#####
## Validate the following input variables:
##
$new_username = sanitize($_POST[new_username]);
$uid = sanitize($_POST[uid]);
$gid = sanitize($_POST[gid]);

$acct_bit = array();
$_POST[acct_bit0] == "on" ? $acct_bit[0] = 1 : $acct_bit[0] = 0;
$_POST[acct_bit1] == "on" ? $acct_bit[1] = 1 : $acct_bit[1] = 0;
$_POST[acct_bit2] == "on" ? $acct_bit[2] = 1 : $acct_bit[2] = 0;
$_POST[acct_bit3] == "on" ? $acct_bit[3] = 1 : $acct_bit[3] = 0;
$_POST[acct_bit4] == "on" ? $acct_bit[4] = 1 : $acct_bit[4] = 0;
$_POST[acct_bit5] == "on" ? $acct_bit[5] = 1 : $acct_bit[5] = 0;
$_POST[acct_bit6] == "on" ? $acct_bit[6] = 1 : $acct_bit[6] = 0;
$_POST[acct_bit7] == "on" ? $acct_bit[7] = 1 : $acct_bit[7] = 0;
$_POST[acct_bit8] == "on" ? $acct_bit[8] = 1 : $acct_bit[8] = 0;
$acct_bits = join("",array_reverse($acct_bit));

#	$body .= "Bit-test: $acct_bits<br>\n";

$dbh = db_connect();
$db_query = "SELECT realname,reference_email,uid,gid,account_class FROM users WHERE username = '$username'";
$sth = pg_query($dbh,$db_query);
$numrows = pg_numrows($sth);
$result = pg_fetch_row($sth,0);

	$db_realname = $result[0];
	$db_reference_email = $result[1];
	$db_uid = $result[2];
	$db_gid = $result[3];
	$db_account_class = $result[4];

### Compare the fields to see if anything's changed. Update DB or create task as neeed.

	$date = time();
	#####
	## Check for base information changes.
	##

	### username - important. This change should be first.
	if ($username != $new_username) {
		## Check the new username and make sure it's not already in use.
		$db_query = "SELECT uid FROM users WHERE username = '$new_username'";
		$sth = pg_query($dbh,$db_query);
		$username_in_use = pg_numrows($sth);
		if ($username_in_use > 0) {
			$db_query = "fail";
		} else {
			# Make DB update IMMEDIATELY for this one. Reason being, if it fails, we don't want the other queries to run against the wrong userid!
			$db_query = "UPDATE users SET username = '$new_username' WHERE uid = '$db_uid'";
			$db_queries[] = "INSERT INTO task_log (account,assignedby,date,service,command) VALUES('$username','$user','$date','account','username=$new_username')";
		}
		$sth = pg_query($dbh,$db_query);
		if ($sth) {
			# Success (expected).
			#Change effective username for the rest of the script in order to ensure that all changes take place.
			$username = $new_username;
		} else {
			$body .= "<font color=\"red\">Error- Failed to change username to </font>$new_username<font color=\"red\">. Reverting to old username.</font><br>\n";
		}
	} # End if username is different than new username.

	### uid
	if ($uid != $db_uid) {
		$db_queries[] = "UPDATE users SET uid = '$uid' WHERE username = '$username'";
		$db_queries[] = "INSERT INTO task_log (account,assignedby,date,service,command) VALUES('$username','$user','$date','account','uid=$uid')";
		$body .= "UID updated to $uid.<br>\n";
	} #End if uid is different

	### gid
	if ($gid != $db_gid) {
		$db_queries[] = "UPDATE users SET gid = '$gid' WHERE username = '$username'";
		$db_queries[] = "INSERT INTO task_log (account,assignedby,date,service,command) VALUES('$username','$user','$date','account','gid=$gid')";
		$body .= "GID updated to $gid.<br>\n";
	} #End if gid is different

	### acct_bits
	$account_class = bindec($acct_bits);
	if ($account_class != $db_account_class) {
		$db_queries[] = "UPDATE users SET account_class = '$account_class' WHERE username = '$username'";
		$db_queries[] = "INSERT INTO task_log (account,assignedby,date,service,command) VALUES('$username','$user','$date','account','account_class=$account_class')";
		$body .= "Account class updated to $account_class ($acct_bits).<br>\n";
	} #End if account_class is different

	#####
	## Okay, that's the end of the fun stuff. The stuff below is mildly more complicated. These happen regardless of rawsql's setting.
	##

	if ($realname != $db_realname) {
		$db_queries[] = "UPDATE users SET realname = '$realname' WHERE username = '$username'";
		$db_queries[] = "INSERT INTO task_log (account,assignedby,date,service,command) VALUES('$username','$user','$date','account','realname=$realname')";
		$body .= "Updated real name to ($realname).<br>\n";
	}
	if ($db_reference_email != $reference_email) {
		$ret_array = is_valid_email_addr($reference_email);
		if ($ret_array[0]) {
			#Email addr is valid!
			$db_queries[] = "UPDATE users SET reference_email = '$reference_email' WHERE username = '$username' AND reference_email = '$db_reference_email'";
			$db_queries[] = "INSERT INTO task_log (account,assignedby,date,service,command) VALUES('$username','$user','$date','account','reference_email=$reference_email')";
			$body .= "Updated reference email address ($_POST[reference_email]).<br>\n";
		} else {
			$body .= "<font color=red>The email address you gave ($_POST[reference_email]) appears to be invalid ($ret_array[1]). Not changing.</font><br>\n";
		}
	}

	if (count($db_queries)) {
		pg_query($dbh,"BEGIN");
		for ($n = 0; $n <= count($db_queries);$n++) {
			pg_query($dbh,$db_queries[$n]);
		}
		#Write changes to database.
		$sth = pg_query($dbh,"COMMIT");
		if (!$sth) { $body .= "Change request FAILED! (".pg_last_error().")";}
		$body .= "<hr width=40%>\n<br>Any name or email changes occur immediately.<br>
		Feature changes go into the <a href=\"pending_tasks.php\">Pending Tasks</a>.<br>
		A message will be left for you when the changes have been made.<br>\n";
	} else {
		pg_query($dbh,"ROLLBACK");
###		$body .= "No changes made!<br>\n";
	}


###
### Build the array of features configuration and send it off for changes.
###

$features_default = get_features();
$features_user = get_features($username);

foreach ($_POST as $key => $value) {
	if (strstr($key,"feature-")) {
		$tmparray = explode("-",$key);
		$feat = $tmparray[1];
		$setting = $tmparray[2];
		$features[$feat][$setting] = $value;
	} #End if
} #End foreach

### Do the required sanity checks on the features.
##
# 1. web_domain
if ($features[web_domain][enabled] == 't') {
	$result = is_valid_web_domain($features[web_domain][config],$username);
	if ($result == 0) {
		$body .= "Web domain was invalid - ignoring change.<br>\n";
		$features[web_domain] = $features_user[web_domain];
	}
}
# 2. web (description)
$features[web][config] = strip_tags($features[web][config]);
# 3. quota
if (!is_numeric($features[quota][config])) {
	$body .= "Quota format invalid - ignoring change.<br>\n";
	$features[quota] = $features_user[quota];
}

### Okay, it's safe to push the feature changes.
##
$changes = set_features($username,$user,$features);
if ($changes == -1) {
	# Features changes failed.
	$body .= "Feature updates failed for user <b>$username</b>!<br>\n";
} else {
	foreach ($changes as $feat => $feat_array) {
		$body .= "Updating <b>$feat</b> feature for user <b>$username</b><br>\n";
	} #End foreach
} #End if


#####
### Link back to the userlist.
#
$body .= "<br><a href=\"admin_edituser.php?username=$username\">Back to user $username</a> | \n";
$body .= "<a href=\"admin_userlist.php\">Back to the User List</a><br>\n";

pg_close($dbh);

$pd = array(	user	=> "$user",
		page	=> "admin - edit user - $username",
		title	=> "Admin: Edit User - $username",
		body	=> $body
		); # End of array for page display
write_page($pd);

?>
