<?
require("inc.config.php");
require("inc.auth.php");

if (authlevel($user) == 7) {
	$dbh = db_connect();
	$date = time();

	if (isset($_POST[execute])) {
		# This is a post routine. Make changes.
		while (!is_null($key = key($_POST))) {
        	        if ($_POST[$key] == "delete") {
        	                $deletions[] = $key;
			} elseif ($_POST[$key] == "exempt") {
				$exemptions[] = $key;
			}
			next($_POST);
		} #End the creative foreach key of $_POST
		for ($n = 0; $n < count($deletions);$n++) {
			$result = delete_user($deletions[$n],$user);
			if ($result) {
				$body .= "Failed to add deletion task for $deletions[$n]!<br>\n";
			} else {
				$body .= "<b>$deletions[$n]</b> is queued for <font color='red'>deletion</font>.<br>\n";
			}
		} #End for each deletion
		for ($n = 0; $n < count($exemptions);$n++) {
			$my_uname = $exemptions[$n];
			$db_query = "SELECT account_class FROM users WHERE username = '$my_uname'";
			$sth = pg_query($dbh,db_query);
			$numrows = pg_numrows($sth);
			if ($numrows != 1) {
				$body .= "Could not get account class for $exemptions[$n]<br>\n";
			}
			$result = pg_fetch_row($sth,0);
			$account_class = $result[0] + 8;
			$db_query = "UPDATE users SET account_class = '$account_class' WHERE username = '$exemptions[$n]'";
			$sth = pg_query($dbh,$db_query);
			if (!$sth) {
				$body .= "Failed to idle-exempt $exemptions[$n]!<br>\n";
			} else {
				$body .= "<b>$exemptions[$n]</b> is now <font color='green'>idle-exempt</font>.<br>\n";
			}

		} #End for each exemption

	} else { #End if _POST
		# Pull the list of idle accounts
		$idle_file = file_get_contents("/vsn/admin/log/idle_users.log");
		$idle_array = explode("\n",$idle_file);
		$body .= "<form method='POST' action='admin_idle.php'>
		<input type='hidden' name='execute' value='1'>
		<table><tr bgcolor='#333366'>
		<td>Username</td><td>Real Name</td><td>Account Created</td><td>Days Idle</td><td>Delete?</td><td>Exempt?</td><td>Ignore?</td>
		</tr>\n";

		for ($n = 0; $n < count($idle_array); $n++) {
			if (strlen($idle_array[$n]) == 0) {
				continue;
			}
			$result = explode("\t",$idle_array[$n]);
			$username = $result[0];
			$days_idle = $result[1];

			# Make sure the user exists.
			if (!user_exists($username)) {
#$body .= "WARNING: User does not exist: $username<br>\n";
				continue;
			}
			if (is_idle_exempt($username)) {
				continue;
			}

			### Retrieve their real name and account creation from
			###  the database.
			$db_query = "SELECT realname,created FROM users WHERE username = '$username'";
			$sth = pg_query($dbh,$db_query);
			$result = pg_fetch_row($sth,0);
			$realname = $result[0];
			$created = nice_time($result[1]);
			$z++;
			if (is_int($z/2)) {
				$body .= "<tr bgcolor='#000000'>";
			} else {
				$body .= "<tr bgcolor='#181818'>";
			}
			$body .= "
				<td>$username</td>
				<td>$realname</td>
				<td>$created</td>
				<td>$days_idle days</td>
				<td><input type='radio' name='$username' value='delete'></td>
				<td><input type='radio' name='$username' value='exempt'></td>
				<td><input type='radio' name='$username' value=''></td>
				</tr>\n";
		} #End for
	
	} #End else (the GET routine)
	$body .= "</table>
		<input type='submit' value='Make changes now'";

	$pd = array(	user	=> "$user",
		page	=> "admin- idle users",
		title	=> "Admin: Idle Users",
		body	=> $body
		); # End of array for page display
	write_page($pd);

} else {
	# Some non-staff asshole is trying to get up in this bitch
	Header("Location: index.php");
	exit;
}

?>
