#!/usr/bin/perl

###  Loading Requirements (equiv of C include)
require "lib/environment";
require "lib/utils";
&loadenv(%ENV);

###  Last Updated: 03/15/2000
###
###  This is mah Super CGI Template.
###
###  The last update added this errlog_updated scalar to see if an error has 
###  occurred. In fact, it reports the cumulative number of errors so far.

#$errlog_updated = 0;

print "Content-type:text/html\n\n";

# --------------------------------------------------------------------------

### First, load a list of users with html documents present.

#@sites = `find /home -name ".description" | grep "public_html/.description"`;
@sites = `ls /home/*/public_html/index.*`;

foreach $site (@sites) {
	($dump,$dump,$user,$dump,$dump) = split(/\//i,$site);
	if ($users[$#users] ne $user) {
		push(@users,$user);
	}
}

### Now, load up the virtual hosts data file.

open(FILE,"/vsn/admin/vhosts/hosts.dat") or dienice("Could not open hosts.dat file to build domain information.");
@hosts = <FILE>;
close(FILE);

foreach $host (@hosts) {
	chomp($host);
	if (substr($host,0,1) ne "#") {
		($type,$user,$domain) = split(/ /i,$host);
		$subdomain{$user} = $domain;
	}
}

###  Subroutines.

sub list_users {
	foreach $user (@users) {
		$description = get_desc($user);
		if (defined($subdomain{$user})) {
			print "<a href=\"http://$subdomain{$user}/\" target=\"_new\">$user</a> - $description<br>\n";
		} else {
			print "<a href=\"/~$user/\" target=\"_new\">$user</a> - $description<br>\n";
		}
	#end foreach
	}
#End Sub
}

sub get_desc {
	my($user) = @_;

	$desc = `cat ~$user/public_html/.description`;
	if (length($desc) > 150) {
		$desc = substr($desc,0,150);
	}

        #This loop removes HTML tags nicely
        while (index($desc,"<") > -1 && index($desc,">") > -1) {
                $first = index($desc,"<");
                $second = index($desc,">");
                $html_tag = substr($desc,$first,$second - $first + 1);
                $desc =~ s/$html_tag//g;
        }

	return $desc;
}



# --------------------------------------------------------------------------
# Time to print out some loveliness.
# --------------------------------------------------------------------------

open(FILE,"templates/users.html") or dienice("Could not open template file.");
@fdata = <FILE>;
close(FILE);

foreach $line (@fdata) {
	$template .= $line;
}

($first,$last) = split(/<split>/i,$template);
print $first;
	&list_users;
print $last;
# --------------------------------------------------------------------------
# We are Officially All Done.
# --------------------------------------------------------------------------


