<?
require("inc.config.php");
require("inc.auth.php");

##
$MSGS_PER_PAGE = 20;
##

$dbh = db_connect();
$fdbh = db_connect("vectorboard");
$date = time();

if (isset($_GET[forum])) { $forum = sanitize($_GET[forum]); }
isset($_GET[page]) ? $page = sanitize($_GET[page]) : $page = 1;


if (!isset($_GET[forum])) {
	# Give them a list of forums.
	$db_query = "SELECT name,description FROM rooms WHERE active = true ORDER BY forumnum";
	$fsth = pg_query($fdbh,$db_query);
	$numrows = pg_numrows($fsth);
	$body .= "<table class='forumtable' cellpadding=0>
		<tr bgcolor='#222244'><td><b>Forum</b></td>
		<td><b>Active Threads</b></td>
		<td><b>Last Post</b></td></tr>";
	for ($n = 0; $n < $numrows;$n++) {
		$namedesc = pg_fetch_row($fsth,$n);
		$date_lastweek = $date - (86400 * 7);
		$msgids = array();

		$db_query = "SELECT DISTINCT parent_msg FROM comments_$namedesc[0] WHERE round(date_part('epoch',datetime)) > $date_lastweek";
		$fsth2 = pg_query($fdbh,$db_query);
		$pnumrows = pg_numrows($fsth2);
		for ($p = 0; $p < $pnumrows;$p++) {
			$result = pg_fetch_row($fsth2,$p);
			array_push($msgids,$result[0]);
		}

		$db_query = "SELECT DISTINCT msgnum FROM room_$namedesc[0] WHERE round(date_part('epoch',datetime)) > $date_lastweek";
		$fsth2 = pg_query($fdbh,$db_query);
		$pnumrows = pg_numrows($fsth2);
		for ($p = 0; $p < $pnumrows;$p++) {
			$result = pg_fetch_row($fsth2,$p);
			array_push($msgids,$result[0]);
		}

		$msgids = array_unique($msgids);
		$activethreads = count($msgids);

		$db_query = "SELECT MAX(datetime) FROM comments_$namedesc[0]";
		$fsth2 = pg_query($fdbh,$db_query);
		$datecompare1 = pg_fetch_row($fsth2,0);
		$db_query = "SELECT MAX(datetime) FROM room_$namedesc[0]";
		$fsth2 = pg_query($fdbh,$db_query);
		$datecompare2 = pg_fetch_row($fsth2,0);

		if ($datecompare1[0] > $datecompare2[0]) {
			$db_query = "SELECT datetime,parent_msg,author FROM comments_$namedesc[0] ORDER BY datetime DESC";
		} else {
			$db_query = "SELECT datetime,msgnum,author FROM room_$namedesc[0] ORDER BY datetime DESC";
		}
		$fsth2 = pg_query($fdbh,$db_query);
		$dt_msg_auth = pg_fetch_row($fsth2,0);

		$body .= "\t\t\t<tr bgcolor='#666699'><td colspan=4></td></tr>\n";
		$body .= "<tr><td><a href='forums.php?forum=$namedesc[0]'>$namedesc[1]</a></td>
		<td>$activethreads</td>
		<td><nobr><a href='forums.php?forum=$namedesc[0]&msgnum=$dt_msg_auth[1]' class='menulink'>$dt_msg_auth[0]<br> by <b>$dt_msg_auth[2]</b></a></nobr></td></tr>\n";
	} #End for
	$body .= "</table><br>\n";

# End of display the forum list
} elseif (isset($_GET[msgnum])) {
	# Give them this specific message
	$msgnum = sanitize($_GET[msgnum]);
	$db_query = "SELECT msgnum,author,title,datetime,content FROM room_$forum WHERE msgnum = $msgnum";
	$fsth = pg_query($fdbh,$db_query);
	if (pg_numrows($fsth) != 1) {
		$body .= "<b>Sorry, that message was not found.</b>\n";
	} else {
		$msginfo = pg_fetch_row($fsth,0);
		$body .= "<table class='forumtable' cellspacing=0 cellpadding=0>
		<tr bgcolor='#222244'><td><b>$msginfo[2]</b></td>
		<td align=right><nobr><font size=-2>$msginfo[3]<br>by <b>$msginfo[1]</b></font></nobr></td></tr>
		<tr bgcolor='#666699'><td colspan=2></td></tr>
		<tr><td colspan=2>$msginfo[4]</td></tr>
		</table>\n";

		# Pull the comments
		$db_query = "SELECT commentnum,author,title,content,datetime FROM comments_$forum WHERE parent_msg = '$msgnum' ORDER BY commentnum ASC";
		$fsth = pg_query($fdbh,$db_query);
		$numrows = pg_numrows($fsth);

		$start = ($page - 1) * $MSGS_PER_PAGE;

		$num_pages = $numrows / $MSGS_PER_PAGE;
		if ($num_pages != intval($num_pages)) {
			$num_pages = intval($num_pages) + 1;
		}

		$body .= "<br>\n";

		$body .= "<a href='forums_post.php?forum=$forum&thread=$msgnum'>Reply</a> | \n";
		$body .= "<a href='forums_post.php?forum=$forum&thread=new'>New Thread</a>\n";
		$prevpage = $page - 1;
		$nextpage = $page + 1;
		if ($prevpage) {
			$body .= "| <a href='forums.php?forum=$forum&&msgnum=$msgnum&page=$prevpage'>Previous page</a>\n";
		}
		if ($start + $MSGS_PER_PAGE < $numrows) {
			$body .= "| <a href='forums.php?forum=$forum&msgnum=$msgnum&page=$nextpage'>Next page</a>\n";
		}

		$body .= "<br><br><table class='forumtable' cellspacing=0 cellpadding=0>\n";

		for ($n = $start;$n < $numrows && $n - $start < $MSGS_PER_PAGE;$n++) {
			$commentinfo = pg_fetch_row($fsth,$n);
			$body .= "<tr bgcolor='#666699'><td colspan=2</td></tr>
			<tr bgcolor='#222244'>
			<td><b>$commentinfo[2]<b></td>
			<td align=right><nobr><font size=-2>$commentinfo[4]<br>by <b>$commentinfo[1]</b></font></nobr></td>
			</tr>
			<tr><td colspan=2>$commentinfo[3]</td></tr>\n";
		} #End for

		$body .= "</table><br>\n";
		if ($numrows > 0) {
			$body .= "<a href='forums_post.php?forum=$forum&thread=$msgnum'>Reply</a> | \n";
			$body .= "<a href='forums_post.php?forum=$forum&thread=new'>New Thread</a>\n";
			$prevpage = $page - 1;
			$nextpage = $page + 1;
			if ($prevpage) {
				$body .= "| <a href='forums.php?forum=$forum&&msgnum=$msgnum&page=$prevpage'>Previous page</a>\n";
			}
			if ($start + $MSGS_PER_PAGE < $numrows) {
				$body .= "| <a href='forums.php?forum=$forum&msgnum=$msgnum&page=$nextpage'>Next page</a>\n";
			}
			$body .= "<br><br>\n";
		}
	} #End if message was found
	# End of display a single message
} else {
	# Give them the message list

	## Reorder the message list based on the date of the  comments
	$db_query = "SELECT msgnum,datetime FROM room_$forum";
	$fsth = pg_query($fdbh,$db_query);
	$numrows = pg_numrows($fsth);
	for ($n = 1; $n <= $numrows; $n++) {
		$msginfo = pg_fetch_row($fsth,$n);
		$msgarray[$msginfo[0]] = $msginfo[1];
	}
	## Get a unique instance of parent_msg with the maximum available datetime
	$db_query = "SELECT parent_msg,MAX(datetime) FROM comments_$forum GROUP BY parent_msg";
	$fsth = pg_query($fdbh,$db_query);
	$numrows = pg_numrows($fsth);
	for ($n = 1; $n <= $numrows; $n++) {
		$msginfo = pg_fetch_row($fsth,$n);
		## for each line, if comment datetime is greater than datetime 
		## in array for parent_msg, update datetime for parent_msg
		if ($msginfo[1] > $msgarray[$msginfo[0]]) {
			$msgarray[$msginfo[0]] = $msginfo[1];
		}
	}
	## Now, resort the array based on datetime
	arsort($msgarray);
	## Create a numbered multidimensional array based on this order.
	## This array will be used by the FOR loop that grabs each message.
	$n = 0;
	foreach ($msgarray as $key => $value) {
		$msgs_sorted[$n][msgnum] = $key;
		$msgs_sorted[$n][datetime] = $value;
		$n++;
	}

	$numrows = count($msgarray);
	$start = ($page - 1) * $MSGS_PER_PAGE;

	$num_pages = $numrows / $MSGS_PER_PAGE;
	if ($num_pages != intval($num_pages)) {
		$num_pages = intval($num_pages) + 1;
	}

	$body .= "<a href='forums_post.php?forum=$forum&thread=new'>New Thread</a> | \n";
	$body .= "<a href='forums_search.php?forum=$forum'>Search</a>\n";
	$prevpage = $page - 1;
	$nextpage = $page + 1;
	if ($prevpage) {
		$body .= "| <a href='forums.php?forum=$forum&page=$prevpage'>Previous page</a>\n";
	}
	if ($start + $MSGS_PER_PAGE < $numrows) {
		$body .= "| <a href='forums.php?forum=$forum&page=$nextpage'>Next page</a>\n";
	}

	### The Jump to Page feature...
	$body .= "<br><br><form method='GET' action='forums.php'>
		<input type='hidden' name='forum' value='$forum'>
		Jump to Page: <select name='page'>\n";
	for ($n = 1; $n <= $num_pages;$n++) {
		if ($n == $page) {
			$body .= "\t<option selected>$n\n";
		} else {
			$body .= "\t<option>$n\n";
		}
	}
	$body .= "</select>\n<input type='submit' value='Go'></form>\n";

	$body .= "<table class='forumtable' cellpadding=0>
		<tr bgcolor='#222244'><td><b>Topic</b></td>
		<td><b>Replies</b></td>
		<td width=4></td>
		<td><b>Author</b></td>
		<td width=4></td>
		<td><b>Last Post</b></td></tr>";

	## Write a line for each actual message
	for ($n = $start; $n < $numrows && $n - $start < $MSGS_PER_PAGE;$n++) {
		$msgnum = $msgs_sorted[$n][msgnum];
		$db_query = "SELECT msgnum,title,author,datetime FROM room_$forum WHERE msgnum = '$msgnum'";
		$fsth = pg_query($fdbh,$db_query);
		$msginfo = pg_fetch_row($fsth,0);

		$db_query = "SELECT datetime,author FROM comments_$forum WHERE parent_msg = '$msginfo[0]' ORDER BY datetime DESC";
		$fsth2 = pg_query($fdbh,$db_query);
		$numcomments = pg_numrows($fsth2);
		if ($numcomments > 0) {
			$lpinfo = pg_fetch_row($fsth2,0);
			$lastpost = "<nobr>$lpinfo[0]<br>by <b>$lpinfo[1]</b></nobr>";
		} else {
			$lastpost = "<nobr>$msginfo[3]<br>by <b>$msginfo[2]</b></nobr>";
		}

		$body .= "\t\t\t<tr bgcolor='#666699'><td colspan=6></td></tr>\n";
		$body .= "\t\t\t<tr><td><a href='forums.php?forum=$forum&msgnum=$msginfo[0]'>$msginfo[1]</a></td>
			<td align=center>$numcomments</td>
			<td></td>
			<td><b>$msginfo[2]<b></td>
			<td></td>
			<td><font size=-2>$lastpost</font></td></tr>\n";
	} # End for

	$body .= "</table><br>\n";

	$body .= "<a href='forums_post.php?forum=$forum&thread=new'>New Thread</a> | \n";
	$body .= "<a href='forums_search.php?forum=$forum'>Search</a>\n";
	$prevpage = $page - 1;
	$nextpage = $page + 1;
	if ($prevpage) {
		$body .= "| <a href='forums.php?forum=$forum&page=$prevpage'>Previous page</a>\n";
	}
	if ($start + $MSGS_PER_PAGE < $numrows) {
		$body .= "| <a href='forums.php?forum=$forum&page=$nextpage'>Next page</a>\n";
	}

	$body .= "<br><br>\n";
#End of display the list of messages in forum
}

if (isset($forum)) {
	$db_query = "SELECT description FROM rooms WHERE name = '$forum'";
	$fsth = pg_query($fdbh,$db_query);
	$forumname = pg_fetch_row($fsth);
	$titleappend = " -> <a href='forums.php?forum=$forum'>$forumname[0]</a>";
}

	$pd = array(	user	=> "$user",
		page	=> "Forums",
		title	=> "<a href='forums.php'>Forums</a>".$titleappend,
		body	=> $body
		); # End of array for page display
	write_page($pd);

?>
