<?
require("inc.config.php");
require("inc.auth.php");

$dbh = db_connect();
$fdbh = db_connect("vectorboard");
$date = time();

isset($_POST[forum]) ? $forum = sanitize($_POST[forum]) : $forum = sanitize($_GET[forum]);
isset($_POST[thread]) ? $thread = sanitize($_POST[thread]) : $thread = sanitize($_GET[thread]);

if ($thread == "new") {
	$db_query = "SELECT authlevel_thread FROM rooms WHERE name = '$forum'";
} else {
	$db_query = "SELECT authlevel_post FROM rooms WHERE name = '$forum'";
}
$fsth = pg_query($fdbh,$db_query);
$numrows = pg_numrows($fsth);
$authinfo = pg_fetch_row($fsth,0);
if (authlevel($user) < $authinfo[0]) {
	# This user is not authorized to post to this forum.
	$body .= "Sorry, you do not have sufficient privileges to post to this forum. Have you logged in yet?<br>\n";
} else {
	#Okay, let 'em post.
	if (isset($_GET[thread]) && $thread == "new") {
		# display a new thread page.
		$body .= "
		<form method='POST' action='forums_post.php'>
		<input type='hidden' name='forum' value='$forum'>
		<input type='hidden' name='thread' value='new'>
		<table class='forumtable' cellpadding=0 style='width: 400px'>";

		if ($authinfo[0] == 0 && authlevel($user) == 0) {
			$body .= "<tr><td><b>Your Name:</b></td><td align=right><input type='text' name='author' value='Anonymous' size=48 maxlength=48></td></tr>\n";
		}

		$body .= "<tr bgcolor='#222244'><td><b>Subject:</b></td>
		<td align=right> <input type='text' name='subject' size=48 maxlength=48></td></tr>
		<tr><td colspan=2><textarea cols=60 rows=15 name='content'></textarea></td></tr>
		<tr bgcolor='#666699'><td colspan=2 align=right><input type='submit' value='Post Message'></td></tr>
		</table>
		";

	} elseif (isset($_POST[thread]) && $thread == "new") {
		# Post this new thread to the forum.
# Since PHP5 these dont seem to be needed
#		$subject = addslashes($_POST[subject]);
#		$content = addslashes($_POST[content]);
		$content = ereg_replace("\n","<br>\n",$content);
		$sqldate = date("Y-m-d G:i:s");
		if (authlevel($user) > 0) {
			$author = $user;
		} else {
#			strlen($_POST[author]) > 0 ? $author = "(anon) ".addslashes($_POST[author]) : $author = "Anonymous";
			strlen($_POST[author]) > 0 ? $author = "(anon) ".$_POST[author] : $author = "Anonymous";
		}
		$db_query = "SELECT MAX(msgnum) FROM room_$forum";
		$fsth = pg_query($fdbh,$db_query);
		$numrows = pg_numrows($fsth);
		if ($numrows == 1) {
			$msgnuminfo = pg_fetch_row($fsth,0);
			$msgnum = $msgnuminfo[0] + 1;
			$db_query = "INSERT INTO room_$forum (msgnum,author,title,datetime,content) VALUES('$msgnum','$author','$subject','$sqldate','$content')";
			$fsth = pg_query($fdbh,$db_query);
			if ($fsth === FALSE) {
				$body .= "A Database error occurred - failed to insert your thread into the forum. Please try again.<br>\n";
			} else {
				header("Location: forums.php?forum=$forum&msgnum=$msgnum");
			}

		} else {
			$body .= "A Database error occurred - could not submit your thread. Please try again.<br>\n";
		}

	} elseif (isset($_GET[thread])) {
		# Display a new post to an existing thread page.
		# First, make sure the thread exists.
		$db_query = "SELECT msgnum,author,title,datetime,content FROM room_$forum WHERE msgnum = '$thread'";
		$fsth = pg_query($fdbh,$db_query);
		$numrows = pg_numrows($fsth);
		if ($numrows == 1) {
			$msginfo = pg_fetch_row($fsth,0);

			$body .= "
			<form method='POST' action='forums_post.php'>
			<input type='hidden' name='forum' value='$forum'>
			<input type='hidden' name='thread' value='$thread'>
			<table class='forumtable' cellpadding=0 style='width: 400px'>";
	
			if ($authinfo[0] == 0 && authlevel($user) == 0) {
				$body .= "<tr><td><b>Your Name:</b></td><td align=right><input type='text' name='author' value='Anonymous' size=48 maxlength=48></td></tr>\n";
			}
	
			$body .= "<tr bgcolor='#222244'><td><b>Subject:</b></td>
			<td align=right> <input type='text' name='subject' size=48 maxlength=48 value=\"Re: $msginfo[2]\"></td></tr>
			<tr><td colspan=2><textarea cols=60 rows=15 name='content'></textarea></td></tr>
			<tr bgcolor='#666699'><td colspan=2 align=right><input type='submit' value='Post Message'></td></tr>
			</table><br>\n";

			# Display the original message.
			$body .= "<table class='forumtable' cellpadding=0>
			<tr bgcolor='#222244'><td><b>$msginfo[2]</b></td>
			<td align=right><nobr><font size=-2>$msginfo[3]<br>by <b>$msginfo[1]</b></font></nobr></td></tr>
			<tr bgcolor='#666699'><td colspan=2></td></tr>
			<tr><td colspan=2>$msginfo[4]</td></tr>
			</table><br>\n";



		} else {
			$body .= "Sorry, that thread was not found in the database.<br>\n";
		} #End if numrows == 1 
	} elseif (isset($_POST[thread])) {
		# Post this reply to an existing thread.
		# First, make sure the thread exists.
		$db_query = "SELECT msgnum,author,title,datetime,content FROM room_$forum WHERE msgnum = '$thread'";
		$fsth = pg_query($fdbh,$db_query);
		$numrows = pg_numrows($fsth);
		if ($numrows == 1) {
			# Insert this post to the comments table.
# Since PHP5 these don't seem to be needed
#			$subject = addslashes($_POST[subject]);
#			$content = addslashes($_POST[content]);
			$content = ereg_replace("\n","<br>\n",$content);
			$sqldate = date("Y-m-d G:i:s");
			if (authlevel($user) > 0) {
				$author = $user;
			} else {
#				strlen($_POST[author]) > 0 ? $author = "(anon)".addslashes($_POST[author]) : $author = "Anonymous";
				strlen($_POST[author]) > 0 ? $author = "(anon)".$_POST[author] : $author = "Anonymous";
			}
			$db_query = "SELECT MAX(commentnum) FROM comments_$forum WHERE parent_msg = '$thread'";
			$fsth = pg_query($fdbh,$db_query);
			$cnuminfo = pg_fetch_row($fsth,0);
			$commentnum = $cnuminfo[0] + 1;
			$db_query = "INSERT INTO comments_$forum (commentnum,parent_msg,datetime,author,title,content)
					 VALUES('$commentnum','$thread','$sqldate','$author','$subject','$content')";
			$fsth = pg_query($fdbh,$db_query);
			if ($fsth === FALSE) {
				$body .= "A Database error occurred - failed to post your reply to the thread. Please try again.<br>\n";
			} else {
				header("Location: forums.php?forum=$forum&msgnum=$thread");
			}
		} else {
			$body .= "Sorry, that thread was not found in the database.<br>\n";
		}
	} else {
		# This should never happen. display an error.
		$body .= "Error - Invalid request format. Please don't try to access this page manually - click the appropriate links from the forums.<br>\n";
	} #End the case for get/post/thread/reply
} # End if authlevel is adequate



if (isset($forum)) {
	$db_query = "SELECT description FROM rooms WHERE name = '$forum'";
	$fsth = pg_query($fdbh,$db_query);
	$forumname = pg_fetch_row($fsth);
	$titleappend = " -> <a href='forums.php?forum=$forum'>$forumname[0]</a>";
}

	$pd = array(	user	=> "$user",
		page	=> "Forums - Post",
		title	=> "<a href='forums.php'>Forums</a> -> Post".$titleappend,
		body	=> $body
		); # End of array for page display
	write_page($pd);

?>
