<?
#inc.print.php

###
# Basic Page Printing functions.
###

function go_login($src) {
	if (strlen($src) > 0) {
		Header("Location: login.php?redir=$src");
	} else {
		Header("Location: login.php");
	}	
	exit;
}

function get_template() {
global $ABSOLUTE_PATH;
	$fp = fopen("$ABSOLUTE_PATH/template.html","r");
	while (!feof($fp)) {
		$buffer = fgets($fp,4096);
		$TEMPL .= $buffer;
	}
	fclose($fp);
	return $TEMPL;
}


function write_page($pd) {

	$menu .= "
	<table class='vstable' style='width: 130;'>
	<tr><td>
	<span class=\"menutext\">
	<nobr>
	<a class='menulink' href='frame.php?framesrc=http://mail.vectorstar.net/'>Webmail</a>
	(<a class='menulink' href='frame.php?framesrc=https://mail.vectorstar.net/'>Secure</a>)<br>
	<a class='menulink' href='forums.php'>Forums</a><br>
	<tr><td height=2 bgcolor=\"#606090\"></td></tr>
	<tr><td>
	<a class='menulink' href='frame.php?framesrc=/about/'>About VectorStar</a><br>
	<a class='menulink' href='/free.php'>Free Accounts</a><br>
	<a class='menulink' href='frame.php?framesrc=/info/'>Info/Help</a><br>
	<a class='menulink' href='/contact.php'>Contact Us</a><br>
	</td></tr>
	<tr><td height=2 bgcolor=\"#606090\"></td></tr>
	<tr><td>
	<a class='menulink' href='frame.php?framesrc=http://users.vectorstar.net/'>Users' Sites</a><br>
	<a class='menulink' href='/donations.php'>Donations</a><br>
	<a class='menulink' href='/stuff.php'>Other Stuff</a><br>
	</td></tr>
	</nobr></td></tr></table>
	";

	if (authlevel($pd[user]) > 0) {
		$menu .= "
		<br>
	<table class='vstable' style='width: 130;'>
		<tr><td align=center>
		<b>Your Account:</b>
		</td></tr>
		<tr><td height=2 bgcolor=\"#606090\"></td></tr>
		<tr><td>
		<a class='menulink' href='acct_features.php'>Acct Settings</a><br>
		<a class='menulink' href='passwd.php'>Change Password</a><br>
		<a class='menulink' href='mailfilter.php'>Mail Filtering</a><br>
		<a class='menulink' href='quota.php'>Your Disk Usage</a><br>
		</td></tr>
		<tr><td height=2 bgcolor=\"#606090\"></td></tr>
		<tr><td>
		<a class='menulink' href='webstats.php'>Website Stats</a><br>
		<a class='menulink' href='websiterankings.php'>Website Rankings</a><br>
		<a class='menulink' href='http://users.vectorstar.net/~$pd[user]/usage' target='_new'>Web Bandwidth</a><br>
		</td></tr>
		<tr><td height=2 bgcolor=\"#606090\"></td></tr>
		<tr><td>
		<a class='menulink' href='pending_tasks.php'>Pending Tasks</a><br>
		<a class='menulink' href='message.php'>Messages</a><br>
		</td></tr>
		<tr><td height=2 bgcolor=\"#606090\"></td></tr>
		<tr><td>
		<a class='menulink' href='referrals.php'>Refer New Users</a><br>
		
		</td></tr></table>
		";
	}

	# Write out the stuff for the admins.
	if (authlevel($pd[user]) == 7) {
		$menu .= "
		<br>
	<table class='vstable' style='width: 130;'>
		<tr><td align=center>
		<b>Administration:</b>
		</td></tr>
		<tr><td height=2 bgcolor=\"#606090\"></td></tr>
		<tr><td>
		<a class='menulink' href='admin_status.php'>System Status</a><br>
		</td></tr>
		<tr><td height=2 bgcolor=\"#606090\"></td></tr>
		<tr><td>
		<a class='menulink' href='admin_approve.php'>Approve Signups</a><br>
		<a class='menulink' href='admin_referrals.php'>Active Referrals</a><br>
		<a class='menulink' href='admin_userlist.php'>Edit Users</a><br>
		<a class='menulink' href='admin_idle.php'>Idle Accounts</a><br>
		<a class='menulink' href='admin_duplicate.php'>Duplicate Accts</a><br>
		<a class='menulink' href='admin_pending_tasks.php'>All Pending Tasks</a><br>
		</td></tr></table>
		";
	}

	$out = get_template();
	$out = ereg_replace("__MENU__",$menu,$out);
	$out = ereg_replace("__PAGE__",$pd[page],$out);
	$out = ereg_replace("__TITLE__",$pd[title],$out);
	$out = ereg_replace("__BODY__",$pd[body],$out);
	$out = ereg_replace("__USERNAME__","$pd[user]",$out);

	if (authlevel($pd[user]) > 0) {
		$logoutline = "Logged in as: $pd[user] (<a href=\"logout.php\">Log Out</a>)";
	} else {
		$logoutline = " Not logged in (<a href=\"login.php\">Log In</a>)";
	}
	$out = ereg_replace("__LOGOUT__","$logoutline",$out);

	$num_msgs = has_new_messages($pd[user]);
	if ($num_msgs && strlen($pd[user]) > 0) {
		$token = "<a href=\"message.php\"> You have $num_msgs messages";
		if ($num_msgs == 1) {
			$token = substr($token,0,strlen($token) - 1);
		}
		$token = $token." waiting.</a>\n";
	} else {
		$token = "";
	}
	$out = ereg_replace("__NEWMESSAGE__",$token,$out);

	$jscript_login = "<script language=\"JavaScript\">function dofocus() { document.login.username.focus() }</script>";
	$jscript_onload = "onload=dofocus()";
	if ($pd[page] == "Login") {
		$out = ereg_replace("__JAVASCRIPT__",$jscript_login,$out);
		$out = ereg_replace("__JAVA_ONLOAD__",$jscript_onload,$out);
	} else {
		$out = ereg_replace("__JAVASCRIPT__","",$out);
		$out = ereg_replace("__JAVA_ONLOAD__","",$out);
	}
	echo $out;
}

?>
