<?
require("inc.config.php");
require("inc.auth.php");

if (authlevel($user) <= 0) {
 Header("Location: login.php?redir=referrals.php");
 exit;
}
if (authlevel($user) == 7) {
	$refer_ok = 1;
}

$dbh = db_connect();

if ($_SERVER[REQUEST_METHOD] == "POST") {
	###
	# take input of email_address.
	# Check that they've been a member for at least a year.
	# Check that they haven't added any referrals in the last week.
	###
	$email_address = sanitize($_POST[email_address]);
	$test_result = is_valid_email_addr($email_address);
	if (!$test_result[0]) {
		$body .= "<font color='red'>Sorry, $test_result[1] Please try again.</font><br>";
		$error = 1;
	} else {
		# Okay, the email address looks good.
		$datetime = time();
		$db_query = "INSERT INTO referrals (referredby,datetime,status,email_address) VALUES('$user','$datetime','created','$email_address')";
		$sth = pg_query($dbh,$db_query);
	}
	

$body .= "<br><br>\n";
} #End if server request method is POST

### Begin GET method



# Check if this person qualifies to refer other users.
$db_query = "SELECT created FROM users WHERE username = '$user'";
$sth = pg_query($dbh,$db_query);
$numrows = pg_numrows($sth);
if ($numrows != 1) {
	$body .= "<font color='red'>Sorry, an error occurred while checking for your eligibility to refer users.</font>";
} elseif (!$refer_ok) {
	$result = pg_fetch_row($sth,0);
	$signup_date = $result[0];
	$cur_date = time();
	#1 year = 60 x 60 x 24 x 365
	$oneday = 86400;
	$oneweek = 7 * $oneday;
	$oneyear = $oneday * 365;
	if ($signup_date + $oneyear < $cur_date) {
		$oneweekago = $cur_date - $oneweek;
		$db_query = "SELECT email_address FROM referrals WHERE referredby = '$user' AND datetime > $oneweekago";
		$sth = pg_query($dbh,$db_query);
		$numrows = pg_numrows($sth);
		if ($numrows > 0) {
			$body .= "Since you have referred someone within the last week, you may not refer anyone else right now.<br><br>\n";
		} else {
			$refer_ok = 1;
		} #End if numrows
	} else {
		$body .= "Sorry, you must be a VectorStar member for at least a year before you can refer other users.<br><br>\n";
	} #End if signupdate+oneyear is less than current date
} #End if (big else)

if ($refer_ok) {
	$body .= "
	If you would like to refer someone to VectorStar, Enter their email address below!
	<br><b>
	Please keep in mind, An ISP email address must be used (no free email hosts).
	<br>
	you may only refer one person per week.
	<br>
	If they do not sign up within a week, the referral will be deleted.</b>
	<br><br>
	<form method=\"POST\" action=\"referrals.php\">
	<input type=\"text\" name=\"email_address\" size=32 maxlength=255>
	<input type='Submit' value='Refer this person'>
	</form><br><br>";
}

# Build the referral history table.

$body .= "<b>Below is your referral history:</b>
<br>
<table border=0 cellpadding=2 cellspacing=2>
<tr bgcolor=\"#333366\">
	<td>Date</td>
	<td>User</td>
	<td>Email Address</td>
	<td>Status</td>
</tr>\n";

$p = 0;

# Check real account history
$db_query = "SELECT username,created,reference_email,deleted FROM users_log WHERE referredby = '$user' ORDER BY created DESC";
$sth = pg_query($dbh,$db_query);
$numrows = pg_numrows($sth);

for ($n = 0;$n < $numrows;$n++) {
	$result = pg_fetch_row($sth,$n);

	$username = $result[0];
	$datetime = $result[1];
	$email_address = $result[2];
	$deleted = $result[3];
	$n_datetime = nice_time($datetime);
	if ($deleted > 0) {
		$status = "Deleted ".nice_time($deleted);
	} else {
		$status = "Active User";
	}
	$n_datetime = nice_time($datetime);

	# Display!
	$p++;
	is_int($p/2) ? $bgcolor = "#222222" : $bgcolor = "#181818";
	$body .= "\t<tr bgcolor=\"$bgcolor\">
			<td>$n_datetime</td>
			<td>$username</td>
			<td>$email_address</td>
			<td>$status</td>
	</tr>\n";
} #End for

# Grab running referrals.
$db_query = "SELECT referredby,datetime,email_address,status FROM referrals WHERE referredby = '$user' ORDER BY datetime DESC";
$sth = pg_query($dbh,$db_query);
$numrows = pg_numrows($sth);

for ($n = 0;$n < $numrows;$n++) {
	$result = pg_fetch_row($sth,$n);

	$referredby = $result[0];
	$datetime = $result[1];
	$email_address = $result[2];
	$status = $result[3];
	$n_datetime = nice_time($datetime);

	# From the email address, get the username (if an active member)
	if ($status == "pending") {
		$db_query = "SELECT username FROM signups WHERE reference_email = '$email_address'";
	} elseif ($status == "approved") {
		$db_query = "SELECT username FROM signups_approved WHERE reference_email = '$email_address'";
	} else {
		$db_query = "SELECT username FROM users WHERE reference_email = '$email_address'";
	}

	$sth2 = pg_query($dbh,$db_query);
	$numrows2 = pg_numrows($sth2);
	if ($numrows2 == 0) { 
		$username = "(unknown)";
	} else {
		$result2 = pg_fetch_row($sth2,0);
		$username = $result2[0];
	}
	# Display!
	$p++;
	is_int($p/2) ? $bgcolor = "#222222" : $bgcolor = "#181818";
	$body .= "\t<tr bgcolor=\"$bgcolor\">
			<td>$n_datetime</td>
			<td>$username</td>
			<td>$email_address</td>
			<td>$status</td>
	</tr>\n";
} #End For




$body .= "</table>\n<br><br>\n";

$body .= "\n<br>\n";

$pd = array(	user	=> "$user",
		page	=> "Referrals",
		title	=> "User Referrals",
		body	=> "$body"
		);
write_page($pd);

?>
